#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "memory_allocate.h"
#include "MSI.h"
#include "svd_v2.h"
#include "TABLE.h"
#include "SPECT.h"
#include "NaturalVision.h"
#include "kmeans.h"
#include "Dye.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

void StanDardbykmeans(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_Rsig)
{
	int i,j,k,x,y;
//	char *fn_sys="16b.system";

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);


	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	
	int CLASS=4;
	double *ob_dye;
	double *re_dye;
	ob_dye=dvector(0,dye.Num);
	re_dye=dvector(0,dye.Num);

	double DyeCof[3];

	DyeCof[0]=1.0;
	DyeCof[1]=1.0;//3.809716599; //hematoxylin
	DyeCof[2]=1.0;//6.869876285; //Eosin

	ob_dye=NucDyebyKmeans(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	re_dye=NucDyebyKmeans(fn_Rsig,CLASS,&wimat,&dye,&Grass,&MinusLog10);

	/////////////////////////////////////////////// Calculation of Weighting Factor
	printf("WEIGHT FACTOR \t");
	for(j=1;j<dye.Num;j++){
		DyeCof[j]=re_dye[j]/ob_dye[j];
		printf("%f ",DyeCof[j]);
	}
	printf("\n");

	//////////////////////////////////////////////// Standardization

	int SX=200,EX=1200;
	int SY=200,EY=1200;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_rgb[200];
	RGB rgb;

	ReName(msi.fn,fn_rgb,"_rgbStanDard.raw");
	rgb=RGBinfo(&msi,fn_rgb);


	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
				}
			}
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂĒzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					if(dye.vol[j]>0){
						dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j]*DyeCof[j];
					}else{
						dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
					}
				}
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ChagSpec[i]=dye.ResiSpec[i]+dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
				Do_Minus10Power(&dye.ChagSpec[i],&Minus10Power);
				dye.ChagSpec[i]*=Grass.data[i];//KX̓ߗ
			}
			
			for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				xyz[k]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
					xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*dye.ChagSpec[i];
				}
			}
			
			for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
				irgb[k]=0;
				for(j=0;j<xyzfunc.Num;j++){
					irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
			
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);

		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDardbykmeans(char *fn_wsig,char *fn_Osig,char *fn_Rsig)
{
	int i,j,k,x,y;
	char *fn_sys="16b.system";

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);


	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	
	int CLASS=4;
	double *ob_dye;
	double *re_dye;
	ob_dye=dvector(0,dye.Num);
	re_dye=dvector(0,dye.Num);

	double DyeCof[3];

	DyeCof[0]=1.0;
	DyeCof[1]=1.0;//3.809716599; //hematoxylin
	DyeCof[2]=1.0;//6.869876285; //Eosin

	ob_dye=NucDyebyKmeans(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	re_dye=NucDyebyKmeans(fn_Rsig,CLASS,&wimat,&dye,&Grass,&MinusLog10);

	/////////////////////////////////////////////// Calculation of Weighting Factor
	printf("WEIGHT FACTOR \t");
	for(j=1;j<dye.Num;j++){
		DyeCof[j]=re_dye[j]/ob_dye[j];
		printf("%f ",DyeCof[j]);
	}
	printf("\n");

	//////////////////////////////////////////////// Standardization

	int SX=400,EX=1200;
	int SY=400,EY=1200;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_rgb[200];
	RGB rgb;

	ReName(msi.fn,fn_rgb,"_rgbStanDard.raw");
	rgb=RGBinfo(&msi,fn_rgb);


	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
				}
			}
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂĒzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					if(dye.vol[j]>0){
						dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j]*DyeCof[j];
					}else{
						dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
					}
				}
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ChagSpec[i]=dye.ResiSpec[i]+dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
				Do_Minus10Power(&dye.ChagSpec[i],&Minus10Power);
				dye.ChagSpec[i]*=Grass.data[i];//KX̓ߗ
			}
			
			for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				xyz[k]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
					xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*dye.ChagSpec[i];
				}
			}
			
			for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
				irgb[k]=0;
				for(j=0;j<xyzfunc.Num;j++){
					irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
			
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);

		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDardbykmeansMSI(char *fn_wsig,char *fn_Osig,char *fn_Rsig)
{
	int i,j,k,x,y;
	char *fn_sys="16b.system";

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ

	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);
	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);
	
	int CLASS=4;
	double *ob_dye;
	double *re_dye;
	ob_dye=dvector(0,dye.Num);
	re_dye=dvector(0,dye.Num);

	double DyeCof[3];

	DyeCof[0]=1.0;
	DyeCof[1]=1.0;//3.809716599; //hematoxylin
	DyeCof[2]=1.0;//6.869876285; //Eosin

	ob_dye=NucDyebyKmeans(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	re_dye=NucDyebyKmeans(fn_Rsig,CLASS,&wimat,&dye,&Grass,&MinusLog10);

	/////////////////////////////////////////////// Calculation of Weighting Factor
	printf("WEIGHT FACTOR \t");
	for(j=1;j<dye.Num;j++){
		DyeCof[j]=re_dye[j]/ob_dye[j];
		printf("%f ",DyeCof[j]);
	}
	printf("\n");

	//////////////////////////////////////////////// Standardization

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	unsigned short int *g,*cg;
	double *dg;

#define RBAND 18
#define DARK 1
#define THROUGH 1

	dg=dvector(0,RBAND);
	g=usvector(0,RBAND);
	cg=usvector(0,RBAND);

	char fn_g[200];
	char fn_cg[200];
	char fn_rgb[200];


	RGB rgb;
	ReName(msi.fn,fn_rgb,"_rgbStanDard.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	ReName(msi.fn,fn_g,"_ori.001");
	ReName(msi.fn,fn_cg,"_Std.001");

	FILE *fp,*fp2,*fp3;
	printf("%s\n",fn_rgb);
	printf("%s\n",fn_g);
	printf("%s\n",fn_cg);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	if((fp2 = fopen(fn_g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_g);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fn_cg, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_cg);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}	
			
			g[0]=0;
			for(j=0;j<wimat.BAND;j++){
				dg[j]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
					dg[j]+=wimat.tr_H[i*wimat.BAND+j]*simSpec[i];
				}
				g[j+DARK]=(unsigned short int)dg[j];
				//printf("%d\n",g[j+DARK]);
			}
			g[RBAND-THROUGH]=0;

		
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){	
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
				}
			}
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//cXyNg̎Zo
				dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂĒzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					//dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j]*DyeCof[j];
					if(dye.vol[j]>0){
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j]*DyeCof[j];
				}else{
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];

				}
				}
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ChagSpec[i]=dye.ResiSpec[i]+dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
				Do_Minus10Power(&dye.ChagSpec[i],&Minus10Power);
				dye.ChagSpec[i]*=Grass.data[i];//KX̓ߗ
			}

			cg[0]=0;
			for(j=0;j<wimat.BAND;j++){
				dg[j]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
					dg[j]+=wimat.tr_H[i*wimat.BAND+j]*dye.ChagSpec[i];
				}
				cg[j+DARK]=(unsigned short int)dg[j];
			}
			cg[RBAND-THROUGH]=0;
			
			for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				xyz[k]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
					xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*dye.ChagSpec[i];
				}
			}
			
			for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
				irgb[k]=0;
				for(j=0;j<xyzfunc.Num;j++){
					irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
			
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);
			fwrite(g,sizeof(unsigned short int),RBAND,fp2);
			fwrite(cg,sizeof(unsigned short int),RBAND,fp3);

		}

	}

	fclose(fp);	
	fclose(fp2);	
	fclose(fp3);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDardbykmeansMSI(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_Rsig)
{
	int i,j,k,x,y;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);
	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	
	int CLASS=4;
	double *ob_dye;
	double *re_dye;
	ob_dye=dvector(0,dye.Num);
	re_dye=dvector(0,dye.Num);

	double DyeCof[3];

	DyeCof[0]=1.0;
	DyeCof[1]=1.0;//3.809716599; //hematoxylin
	DyeCof[2]=1.0;//6.869876285; //Eosin

	ob_dye=NucDyebyKmeans(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	re_dye=NucDyebyKmeans(fn_Rsig,CLASS,&wimat,&dye,&Grass,&MinusLog10);

	/////////////////////////////////////////////// Calculation of Weighting Factor
	printf("WEIGHT FACTOR \t");
	for(j=1;j<dye.Num;j++){
		DyeCof[j]=re_dye[j]/ob_dye[j];
		printf("%f ",DyeCof[j]);
	}
	printf("\n");

	//////////////////////////////////////////////// Standardization


	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);


	int SX=0,EX=2048;
	int SY=0,EY=2048;

	unsigned short int *g,*cg;
	double *dg;

	dg=dvector(0,wimat.BAND);
	g=usvector(0,wimat.BAND);
	cg=usvector(0,RBAND);

	char fn_g[200];
	char fn_cg[200];
	char fn_rgb[200];


	RGB rgb;
	ReName(msi.fn,fn_rgb,"_rgbStanDard.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	ReName(msi.fn,fn_g,"_ori.raw");
	ReName(msi.fn,fn_cg,"_Std.raw");

	FILE *fp,*fp2,*fp3;
	printf("%s\n",fn_rgb);
	printf("%s\n",fn_g);
	printf("%s\n",fn_cg);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	if((fp2 = fopen(fn_g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_g);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fn_cg, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_cg);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}	
			
			
			for(j=0;j<wimat.BAND;j++){
				dg[j]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
					dg[j]+=wimat.tr_H[i*wimat.BAND+j]*simSpec[i];
				}
				g[j]=(unsigned short int)dg[j];
				//printf("%d\n",g[j+DARK]);
			}

		
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){	
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
				}
			}
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//cXyNg̎Zo
				dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂĒzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					//dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j]*DyeCof[j];
					if(dye.vol[j]>0){
						dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j]*DyeCof[j];
					}else{
						dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];

					}
				}
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ChagSpec[i]=dye.ResiSpec[i]+dye.LBSpec[i];
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
				Do_Minus10Power(&dye.ChagSpec[i],&Minus10Power);
				dye.ChagSpec[i]*=Grass.data[i];//KX̓ߗ
			}

		
			for(j=0;j<wimat.BAND;j++){
				dg[j]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
					dg[j]+=wimat.tr_H[i*wimat.BAND+j]*dye.ChagSpec[i];
				}
				cg[j]=(unsigned short int)dg[j];
			}
			
			for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				xyz[k]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
					xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*dye.ChagSpec[i];
				}
			}
			
			for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
				irgb[k]=0;
				for(j=0;j<xyzfunc.Num;j++){
					irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
			
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);
			fwrite(g,sizeof(unsigned short int),wimat.BAND,fp2);
			fwrite(cg,sizeof(unsigned short int),wimat.BAND,fp3);

		}

	}

	fclose(fp);	
	fclose(fp2);	
	fclose(fp3);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void Get_MSIsignal(char *fn_wsig,char *fn_spec,char *fn_sys)//ߗf[^}`XyNgMl֕ϊ֐
{
	int i,j,k;
	
	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Spec	obj;//KX̓ߗ
	
	obj=SpecGet(fn_spec);
	
	unsigned short int *g;
	double *dg;

	dg=dvector(0,wimat.BAND*obj.Num);
	g=usvector(0,wimat.BAND*obj.Num);

	char refn[200];
	char cfn[200];
	FILE *fp;
	sprintf(cfn,"_%db.sig",wimat.BAND);
	ReName(fn_spec,refn,cfn);

	if((fp = fopen(refn, "w")) == NULL ) {
		printf("%s I[vG[\n",refn);
		getchar();
		exit(1);
	}
	
	fprintf(fp,"\t");
	for(j=0;j<wimat.BAND;j++){
		fprintf(fp,"BAND%d\t",j);
	}
	fprintf(fp,"\n");

	fprintf(fp,"White\t");
	for(j=0;j<wimat.BAND;j++){
		dg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
			dg[j]+=wimat.tr_H[i*wimat.BAND+j];
		}
		g[j]=(unsigned short int)dg[j];
		fprintf(fp,"%d\t",g[j]);
	}
	fprintf(fp,"\n");



	for(k=0;k<obj.Num;k++){
		fprintf(fp,"DATA%d\t",k+1);
		for(j=0;j<wimat.BAND;j++){
			dg[k*wimat.BAND+j]=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				dg[k*wimat.BAND+j]+=wimat.tr_H[i*wimat.BAND+j]*obj.data[i*obj.Num+k];
			}
			g[k*wimat.BAND+j]=(unsigned short int)dg[k*wimat.BAND+j];
			fprintf(fp,"%d\t",g[k*wimat.BAND+j]);
		}
		fprintf(fp,"\n");
	}

	fclose(fp);

	printf("Make %s !!",refn);

	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	
}

void AdaptiveRBCarea_StanDard16Dim_3dye(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_Rsig)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	char fn_dye16[]="NormalizedR(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ
	Fwrite_TABLE("invrhhe.xls",dye16.Num,dye16.WL,dye16.inv);

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);
//	Fwrite_TABLE("glass16.xls",Grass16.Num,Grass16.WL,Grass16.data);
	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	
	int CLASS=4;

	int cH,cR;
	double min,*dist;
	dist=dvector(0,CLASS);

	double *NucDyeCof;
	double *RBCDyeCof;

	NucDyeCof=dvector(0,dye16.Num);
	RBCDyeCof=dvector(0,dye16.Num);


	for(i=0;i<dye16.Num;i++){
		NucDyeCof[i]=1;
		RBCDyeCof[i]=1;
	}

	NucDyeCof[0]=1.0;
	NucDyeCof[1]=0.841;//3.809716599; //hematoxylin
	NucDyeCof[2]=1.40;//6.869876285; //Eosin

	RBCDyeCof[0]=0.958;//R
	RBCDyeCof[1]=0.780;//3.809716599; //hematoxylin
	RBCDyeCof[2]=1.472;//6.869876285; //Eosin
	
	double *sort_H,*sort_R;
	sort_H=dvector(0,dye.Num*CLASS);
	sort_R=dvector(0,dye.Num*CLASS);

	sort_H=HbyKmeans_sort(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	sort_R=RbyKmeans_sort(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	
	printf("H@Ffʂ\[geNX̕ϐFf\n");
	for(k=0;k<CLASS;k++){
		for(j=0;j<dye.Num;j++){ 		
			printf("%f\t",sort_H[k*dye.Num+j]);
		}
		printf("\n");
	}

	printf("R Ffʂ\[geNX̕ϐFf\n");
	for(k=0;k<CLASS;k++){
		for(j=0;j<dye.Num;j++){ 		
			printf("%f\t",sort_R[k*dye.Num+j]);
		}
		printf("\n");
	}

	int SX=200,EX=1200;
	int SY=200,EY=1200;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_rgb[200];
	char fn_cmap[200];
	RGB rgb;

	ReName(msi.fn,fn_rgb,"_rgbStanDard16_3dye.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	ReName(msi.fn,fn_cmap,"_cmap.raw");


	FILE *fp,*fp2;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	if((fp2 = fopen(fn_cmap, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_cmap);
		getchar();
		exit(1);
	}
	printf("%s",fn_cmap);


	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			/////////////j̈̔///////////////////
			min=100000;
			for(k=0;k<CLASS;k++){
				j=1;//1 is Hematoxylin, 0 is R.B.C when number of basis is 3, 2 is Hematoxylin, 1 is R.B.C when Number of basis is 4
				dist[k]=(sort_H[k*dye.Num+j]-dye16.vol[j])*(sort_H[k*dye.Num+j]-dye16.vol[j]);

				if(min>dist[k]){
					min=dist[k];
					cH=k+1;
				}
			}

			/////////////Ԍ̈̔///////////////////
			min=100000;
			for(k=0;k<CLASS;k++){
				j=0;//1 is Hematoxylin, 0 is R.B.C when number of basis is 3, 2 is Hematoxylin, 1 is R.B.C when Number of basis is 4
				dist[k]=(sort_R[k*dye.Num+j]-dye16.vol[j])*(sort_R[k*dye.Num+j]-dye16.vol[j]);

				if(min>dist[k]){
					min=dist[k];
					cR=k+1;
				}
			}

/*
			if(cH!=CLASS&&cR==CLASS){
				orgb[0]=255;
				orgb[1]=0;
				orgb[2]=0;
			}else if(cH==CLASS&&cR!=CLASS) {

				orgb[0]=0;
				orgb[1]=0;
				orgb[2]=255;

			}else if(cH==CLASS&&cR==CLASS) {

				orgb[0]=255;
				orgb[1]=255;
				orgb[2]=0;

			}else{
				orgb[0]=0;
				orgb[1]=0;
				orgb[2]=0;

			}
			*/

			if(cR==CLASS){
				orgb[0]=255;
				orgb[1]=0;
				orgb[2]=0;
			}else {
				orgb[0]=0;
				orgb[1]=0;
				orgb[2]=0;

			}

			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp2);

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}
			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}
			//		Fwrite_TABLE("Resispec.xls",1,dye16.WL,dye16.ResiSpec);
			for(i=0;i<dye16.WL;i++){//LBɊÂĒzx O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					if(cR==CLASS){
						if(dye16.vol[j]>0){
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*RBCDyeCof[j];
						}else{
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
						}

					}else{
						if(dye16.vol[j]>0){
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*NucDyeCof[j];
						}else{
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
						}
					}
				}
			}	
			//Fwrite_TABLE("cLBspec.xls",1,dye16.WL,dye16.LBSpec);

			for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22
				dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
				dye16.ChagSpec[i]+=Grass16.data[i];
			}
			for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
				Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			}

			///////////////////////////////////16ԂŒ I/////////////////////////

			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(i=0;i<wimat.BAND;i++){
						//irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
						irgb[k]+=StoI[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];

				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
	
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);

		}

	}

	fclose(fp);	
	fclose(fp2);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void AdaptiveRBCarea_StanDard16Dim_4dye(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_Rsig)
{
	int i,j,k,x,y;


	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ
	Fwrite_TABLE("invrhhe.xls",dye16.Num,dye16.WL,dye16.inv);

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	
	int CLASS=4;

	int cH,cR;
	double min,*dist;
	dist=dvector(0,CLASS);

	double *NucDyeCof;
	double *RBCDyeCof;

	NucDyeCof=dvector(0,dye16.Num);
	RBCDyeCof=dvector(0,dye16.Num);


	for(i=0;i<dye16.Num;i++){
		NucDyeCof[i]=1;
		RBCDyeCof[i]=1;
	}

	NucDyeCof[0]=1.0;
	NucDyeCof[1]=0.841;//3.809716599; //hematoxylin
	NucDyeCof[2]=1.40;//6.869876285; //Eosin

	RBCDyeCof[0]=0.958;//R
	RBCDyeCof[1]=0.780;//3.809716599; //hematoxylin
	RBCDyeCof[2]=1.472;//6.869876285; //Eosin
	RBCDyeCof[3]=2.660;//PC1 
	 	 	 
	double *sort_H,*sort_R;
	sort_H=dvector(0,dye.Num*CLASS);
	sort_R=dvector(0,dye.Num*CLASS);

	sort_H=HbyKmeans_sort(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	sort_R=RbyKmeans_sort(fn_Osig,CLASS,&wimat,&dye,&Grass,&MinusLog10);
	
	printf("H@Ffʂ\[geNX̕ϐFf\n");
	for(k=0;k<CLASS;k++){
		for(j=0;j<dye.Num;j++){ 		
			printf("%f\t",sort_H[k*dye.Num+j]);
		}
		printf("\n");
	}

	printf("R Ffʂ\[geNX̕ϐFf\n");
	for(k=0;k<CLASS;k++){
		for(j=0;j<dye.Num;j++){ 		
			printf("%f\t",sort_R[k*dye.Num+j]);
		}
		printf("\n");
	}

	int SX=200,EX=1200;
	int SY=200,EY=1200;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_rgb[200];
	char fn_cmap[200];
	RGB rgb;

	
	ReName(msi.fn,fn_rgb,"_rgbStanDard16_4dye.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	ReName(msi.fn,fn_cmap,"_cmap.raw");


	FILE *fp,*fp2;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	if((fp2 = fopen(fn_cmap, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_cmap);
		getchar();
		exit(1);
	}
	printf("%s",fn_cmap);


	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			/////////////j̈̔///////////////////
			min=100000;
			for(k=0;k<CLASS;k++){
				j=1;//1 is Hematoxylin, 0 is R.B.C when number of basis is 3, 2 is Hematoxylin, 1 is R.B.C when Number of basis is 4
				dist[k]=(sort_H[k*dye.Num+j]-dye16.vol[j])*(sort_H[k*dye.Num+j]-dye16.vol[j]);
				if(min>dist[k]){
					min=dist[k];
					cH=k+1;
				}
			}

			/////////////Ԍ̈̔///////////////////
			min=100000;
			for(k=0;k<CLASS;k++){
				j=0;//1 is Hematoxylin, 0 is R.B.C when number of basis is 3, 2 is Hematoxylin, 1 is R.B.C when Number of basis is 4
				dist[k]=(sort_R[k*dye.Num+j]-dye16.vol[j])*(sort_R[k*dye.Num+j]-dye16.vol[j]);

				if(min>dist[k]){
					min=dist[k];
					cR=k+1;
				}
			}

/*
			if(cH!=CLASS&&cR==CLASS){
				orgb[0]=255;
				orgb[1]=0;
				orgb[2]=0;
			}else if(cH==CLASS&&cR!=CLASS) {

				orgb[0]=0;
				orgb[1]=0;
				orgb[2]=255;

			}else if(cH==CLASS&&cR==CLASS) {

				orgb[0]=255;
				orgb[1]=255;
				orgb[2]=0;

			}else{
				orgb[0]=0;
				orgb[1]=0;
				orgb[2]=0;

			}
			*/

			if(cR==CLASS){
				orgb[0]=255;
				orgb[1]=0;
				orgb[2]=0;
			}else {
				orgb[0]=0;
				orgb[1]=0;
				orgb[2]=0;

			}

			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp2);

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}
			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}
	
			//Ԍ̈ƐԌȊÖ̗ɕ
			for(i=0;i<dye16.WL;i++){//LBɊÂĒzx O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					if(cR==CLASS){
						if(dye16.vol[j]>0){
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*RBCDyeCof[j];
						}else{
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
						}

					}else{
						if(dye16.vol[j]>0){
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*NucDyeCof[j];
						}else{
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
						}
					}
				}
			}	

			for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22
				dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
				dye16.ChagSpec[i]+=Grass16.data[i];
			}
			for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
				Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			}

			///////////////////////////////////16ԂŒ I/////////////////////////

			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(i=0;i<wimat.BAND;i++){
						//irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
						irgb[k]+=StoI[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];

				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
	
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);

		}

	}

	fclose(fp);	
	fclose(fp2);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDard16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_cof)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	
	double *DyeCof;
	int Num,Dim;

	DyeCof=DataGet(fn_cof,&Num,&Dim);

	for(i=0;i<Dim;i++){
		printf("Dye%d = %f\t",i+1,DyeCof[i]);
	}
	printf("\n");


	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_rgb[200];
	char fn_cmap[200];
	RGB rgb;

	ReName(msi.fn,fn_rgb,"_STD16.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	ReName(msi.fn,fn_cmap,"_cmap.raw");

	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}
			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}
			for(i=0;i<dye16.WL;i++){//LBɊÂĒzx O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){

					if(dye16.vol[j]>0){
						dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*DyeCof[j];
					}else{
						dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
					}
				}
			}	

			for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22
				dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
				dye16.ChagSpec[i]+=Grass16.data[i];
			}
			for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
				Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			}

			///////////////////////////////////16ԂŒ I/////////////////////////

			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(i=0;i<wimat.BAND;i++){
						//irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
						irgb[k]+=StoI[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
	
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);
		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDard16Dim_NORESI(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_cof)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	char fn_grass16[]="grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//**************************  FfʂɊ|W̓ǂݍ݁@**********************************
	double *DyeCof;
	int Num,Dim;
	DyeCof=DataGet(fn_cof,&Num,&Dim);

	for(i=0;i<Dim;i++){
		printf("Dye%d = %f\t",i+1,DyeCof[i]);
	}
	printf("\n");

	if(dye16.Num!=(Num*Dim)){
		printf("Mistake selected coefficient file %s!!\n",fn_cof);
		printf("Also, mistake selected dye spectral absorption file\n %s!!\n",fn_dye16);
		getchar();
		exit(1);
	}


	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	//**************************  ot@Cifn_rgbǰ@**********************************
	char fn_rgb[200];
	char name[200];
	if((Num*Dim)==3){
		sprintf(name,"_STD16(%ccof%.2f_%.2f_%.2f)_Dye%d_NORESI.raw",fn_cof[0],DyeCof[0],DyeCof[1],DyeCof[2],dye16.Num);
	}
	else if((Num*Dim)==4){ 
		sprintf(name,"_STD16(%ccof%.2f_%.2f_%.2f_%.2f)_Dye%d_NORESI.raw",fn_cof[0],DyeCof[0],DyeCof[1],DyeCof[2],DyeCof[3],dye16.Num);
	}
	else{
		printf("Mistake selected coefficient file %s!!\n",fn_cof);
		getchar();
		exit(1);
	}

	RGB rgb;
	ReName(msi.fn,fn_rgb,name);
	rgb=RGBinfo(&msi,fn_rgb);


	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}
			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}
			for(i=0;i<dye16.WL;i++){//LBɊÂĒzx O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){

					if(dye16.vol[j]>0){
						dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*DyeCof[j];
					}else{
						dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
					}
				}
			}	

			for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22 
				//dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
				dye16.ChagSpec[i]=dye16.LBSpec[i];//c𑫂Ȃ
			}

			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
				dye16.ChagSpec[i]+=Grass16.data[i];
			}
			for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
				Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			}

			///////////////////////////////////16ԂŒ I/////////////////////////

			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(i=0;i<wimat.BAND;i++){
						//irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
						irgb[k]+=StoI[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
	
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);
		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDard_2Cof_16Dim_NORESI(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_BIimage,char *fn_dye16,char *fn_ncof,char *fn_rcof)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//**************************  FfʂɊ|W̓ǂݍ݁@**********************************
	double *Ncof,*Rcof;
	int nNum,nDim;
	int rNum,rDim;
	int tp;

	//j̈悩狁߂␳W̓ǂݍ
	Ncof=DataGet(fn_ncof,&nNum,&nDim);//nNum=1, nDim=3;
	for(i=0;i<nDim;i++){
		printf("Dye%d = %f\t",i+1,Ncof[i]);
	}
	printf("\n");

	//Ԍ̈悩狁߂␳W̓ǂݍ
	Rcof=DataGet(fn_rcof,&rNum,&rDim);//rNum=1, rDim=4;
	for(i=0;i<rDim;i++){
		printf("Dye%d = %f\t",i+1,Rcof[i]);
	}
	printf("\n");

	if(nDim>rDim){
		tp=nDim;
	}else if(nDim==rDim) {
		tp=nDim;
	}else{
		tp=rDim;
	}

	if(dye16.Num!=tp){
		printf("Mistake selected dye spectral absorption file %s\n",fn_dye16);
		printf("Please select dye spectral absoption one more!!\n");
		getchar();
		exit(1);
	}


	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);


	//**************************  ot@Cifn_rgbǰ@**********************************
	char fn_rgb[200];
	char name[200];
	sprintf(name,"_STD16(Dye%d%ccof_Dye%d%ccof)_NORESI.raw",nDim,fn_ncof[0],rDim,fn_rcof[0]);

	RGB rgb;
	ReName(msi.fn,fn_rgb,name);
	rgb=RGBinfo(&msi,fn_rgb);


	//******************************* 2lʉ摜ǂݍ****************************************
	unsigned char *BIimg;//2l摜
	int Pix;//f

	BIimg=GetCharImg(fn_BIimage,&Pix);
	
	if(Pix!=(msi.X*msi.Y)){
		printf("Mistake selected file is %s\n",fn_BIimage);
		getchar();
		exit(1);
	}


	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}

			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}
			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂĒzx O.K. 07/05/22
				dye16.LBSpec[i]=0;

				if(BIimg[y*msi.X+x]==0){//Ԍ̈ȊȎgDvfɑ΂Ċj狁߂␳WZ
					
					for(j=0;j<nDim;j++){//nDim=3@!!

						if(dye16.vol[j]>0){
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*Ncof[j];
						}else{
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
						}
					}
				}else{//Ԍ̈ɑ΂ĕ␳WZ
					
					for(j=0;j<rDim;j++){//rDim=3 or 4 
						if(dye16.vol[j]>0){
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j]*Rcof[j];
						}else{
							dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
						}
					}

				}

			}	

			for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22 
				//dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
				dye16.ChagSpec[i]=dye16.LBSpec[i];//c𑫂Ȃ
			}

			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
				dye16.ChagSpec[i]+=Grass16.data[i];
			}
			for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
				Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			}

			///////////////////////////////////16ԂŒ I/////////////////////////

			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(i=0;i<wimat.BAND;i++){
						//irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
						irgb[k]+=StoI[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
	
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);
		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDard_ROI_Spect_Dye_LAB_16Dim_NORESI(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_ROI,char *fn_cof,char *WFileName)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//ϐFf
	double *ave_dye;
	ave_dye=dvector(0,dye16.Num);

	//XyNg덷 cXyNg֘A
	
	double *Ave_LB;//ߗ
	double *Ave_OD_LB;//zx

	//************* ߗ ***********************
	Ave_LB=dvector(0,dye16.WL);//LBōč\ꂽXyNg

	//************* zx ***********************
	Ave_OD_LB=dvector(0,dye16.WL);//LBōč\ꂽXyNg

	//**************************  FfʂɊ|W̓ǂݍ݁@**********************************
	double *cof;
	int Num,Dim;

	//␳W̓ǂݍ
	cof=DataGet(fn_cof,&Num,&Dim);//Num=1,
	for(i=0;i<Dim;i++){
		printf("Dye%d = %f\t",i+1,cof[i]);
	}
	printf("\n");

	if(dye16.Num!=Dim){
		printf("Mistake selected dye spectral absorption file %s\n",fn_dye16);
		printf("Please select dye spectral absoption one more!!\n");
		getchar();
		exit(1);
	}


			
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz,*xyz_LB;//XYZl

	xyz=dvector(0,xyzfunc.Num);
	xyz_LB=dvector(0,xyzfunc.Num);
	
	double *lab_LB;//LABl
	double *Ave_Lab_LB;

	lab_LB=dvector(0,xyzfunc.Num);
	Ave_Lab_LB=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	
	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fnd[200],name_dye[200];//̐Ff
	char fnl[200],name_lab[200];//L*a*b*l
	char fna[200],name_ave[200];//
	char fn_Alab[200],name_Avelab[200];//L*a*b*@Kv
	char fn_Resi[200],name_AveResi[200];// spectral transmittance @@Kv
	char fn_OD_Resi[200],name_AveOD_Resi[200];// spectral transmittance @Kv


	sprintf(name_dye,"_Dye%d.txt",dye16.Num);//fp2
	sprintf(name_lab,"_Lab_Dye%d.txt",dye16.Num);//fp3

	sprintf(name_ave,"_ave_Dye%d.txt",dye16.Num);//fp5
	sprintf(name_Avelab,"_ave_Lab_Dye%d.txt",dye16.Num);//fpl
	sprintf(name_AveResi,"_ave_trans_Dye%d.spec",dye16.Num);//fp_re
	sprintf(name_AveOD_Resi,"_ave_OD_Dye%d.spec",dye16.Num);//fp_o

	ReName(WFileName,fnd,name_dye);
	ReName(WFileName,fnl,name_lab);

	ReName(WFileName,fna,name_ave);

	ReName(WFileName,fn_Alab,name_Avelab);//ρ@l*a*b*l	
	ReName(WFileName,fn_Resi,name_AveResi);//ρ@cXyNg@ߗ
	ReName(WFileName,fn_OD_Resi,name_AveOD_Resi);//ρ@cXyNg zx


	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("Check_ROIdata.xls",&roi);

	FILE *fp2,*fp3,*fp5;
	FILE *fp_l,*fp_re,*fp_o;

	double *dg;
	dg=dvector(0,wimat.BAND);//ϐMl

	if((fp2 = fopen(fnd, "aw")) == NULL ) {//Ffʁ@@u_Dye%d.txtvt@C
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "aw")) == NULL ) {//l*a*b*@_Lab_Dye.txt
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}

	if((fp5 = fopen(fna, "aw")) == NULL ) {//ϐFfʂ̏o@_ave_Dye.txt
		printf("%s I[vG[\n",fna);
		getchar();
		exit(1);
	}

	if((fp_l = fopen(fn_Alab, "aw")) == NULL ) {//_ave_Lab_Dye%d.txt 
		printf("%s I[vG[\n",fn_Alab);
		getchar();
		exit(1);
	}

	if((fp_re = fopen(fn_Resi, "aw")) == NULL ) {// ̕ϓߗ̏o _ave_trans_Dye%d.spec
		printf("%s I[vG[\n",fn_Resi);
		getchar();
		exit(1);
	}

	if((fp_o = fopen(fn_OD_Resi, "aw")) == NULL ) {// ̕ϋzx̏o _ave_OD_Dye%d.spec
		printf("%s I[vG[\n",fn_OD_Resi);
		getchar();
		exit(1);
	}

	fseek(fp2,  0L, SEEK_END);
	printf("t@Cʒu = %ld\n",ftell(fp2));

	if(ftell(fp2)==0){



		fprintf(fp2,"FileName\tDATA\t");
		for(i=0;i<dye16.Num;i++){//FfʎZo
			fprintf(fp2,"DYE%d\t",i+1);
		}
		fprintf(fp2,"\n");

		fprintf(fp3,"FileName\tDATA\t");//l*a*b*@_Lab_Dye.txt
		for(i=0;i<xyzfunc.Num;i++){//FfʎZo
			fprintf(fp3,"LB_Lab%d\t",i+1);
		}
		fprintf(fp3,"\n");


		fprintf(fp5,"FileName\t");//_ave_Dye.txt

		for(i=0;i<dye16.Num;i++){//FfʎZo
			fprintf(fp5,"ave_DYE%d\t",i+1);
		}
		fprintf(fp5,"\n");

		//L*a*b*l _ave_Lab_Dye.txt
		fprintf(fp_l,"FileName\tave_L*_LB\tave_a*_LB\tave_b*_LB\n");
		

		//ώcXyNg̎Zo  ߗ
		fprintf(fp_re,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp_re,"spe%d\t",i+1);
		}
		fprintf(fp_re,"\n");

		//ώcXyNg̎Zo  zx
		fprintf(fp_o,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp_o,"spe%d\t",i+1);
		}
		fprintf(fp_o,"\n");

	}else{


		fprintf(fp2,"\n");
		fprintf(fp3,"\n");


	}

	fseek(fp2,  0L, SEEK_SET);
//	printf("t@Cʒu = %ld\n",ftell(fp));

//****************         @**************************************

	for(j=0;j<dye16.Num;j++){//Ff
			ave_dye[j]=0;
	}

	for(j=0;j<xyzfunc.Num;j++){//Ff
			Ave_Lab_LB[j]=0;
	}

	for(i=0;i<dye16.WL;i++){//residual in transmittance space
		Ave_LB[i]=0;
	}

	for(i=0;i<dye16.WL;i++){//residual in optical density space
		Ave_OD_LB[i]=0;
	}


//*******************       [vJn@**************************************	
	for(int n=0;n<roi.Num;n++){//ROI̐for[v

		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];
		}

		///////////////////////////////////16ԂŒ@Jn/////////////////////////

		for(i=0;i<wimat.BAND;i++){//ߗMlZo
			spec16[i]=dg[i]/wg[i];
		}

		for(i=0;i<wimat.BAND;i++){//zx֕ϊ
			Do_MinusLog10(&spec16[i],&MinusLog10);
		}

		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
			spec16[i]-=Grass16.data[i];
		}

		//d݌W̓KpɂFfʒ
		fprintf(fp2,"%s\tAdju_DYE",fn_ROI);
		for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
			dye16.vol[j]=0;
			for(i=0;i<dye16.WL;i++){
				dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
			}

			if(dye16.vol[j]>0){
				dye16.vol[j]*=cof[j];//FfʂKp
			}
			fprintf(fp2,"\t%f",dye16.vol[j]);
			ave_dye[j]+=dye16.vol[j];
		}
		fprintf(fp2,"\n");

		for(i=0;i<dye16.WL;i++){//LBɊÂĒzx  data[WL][Num]  O.K. 07/05/22
			dye16.LBSpec[i]=0;
			for(j=0;j<dye16.Num;j++){
				dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
			}
		}

		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
			dye16.LBSpec[i]+=Grass16.data[i];//Ffŕ\XyNg
		}

		//*******************   Averaged original and LB and residual in optical density space ***********************
		for(i=0;i<dye16.WL;i++){
			Ave_OD_LB[i]+=dye16.LBSpec[i];
		}
		//*****************************************************************************

		for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
			Do_Minus10Power(&dye16.LBSpec[i],&Minus10Power);
		}

		/// *************        Normalized Square Error  in transmittance space   ******************

		for(i=0;i<dye16.WL;i++){//residual in transmittance space
			Ave_LB[i]+=dye16.LBSpec[i];
		}

		/// *************         LBŕ\ߗ狁߂L*a*b*@                ******************
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz_LB[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz_LB[k]+=StoX[k*wimat.BAND+i]*dye16.LBSpec[i]*wg[i];
			}
		}
		XYZtoLAB(xyz_LB,whi_xyz,lab_LB);
	
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				Ave_Lab_LB[k]+=lab_LB[k];
		}	
	

		/// *************         L*a*b*l̏o@                ******************
		fprintf(fp3,"%s\tLab",fn_ROI);
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"\t%f",lab_LB[k]);
		}
		fprintf(fp3,"\n");//Fo

	}

	// ***************************   ϐFfʂ̏o     ***********************************
	fprintf(fp5,"%s",fn_ROI);//Fo
	for(j=0;j<dye16.Num;j++){//Ff
			ave_dye[j]/=roi.Num;
			fprintf(fp5,"\t%f",ave_dye[j]);
	}
	fprintf(fp5,"\n");

	
	// ***************************   cXyNg̏o   ߗ  ***********************************

	fprintf(fp_re,"%s\tAdj_LB",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_LB[j]/=roi.Num;
		fprintf(fp_re,"\t%f",Ave_LB[j]);
	}
	fprintf(fp_re,"\n");

	// ***************************   cXyNg̏o   zx  ***********************************

	fprintf(fp_o,"%s\tAdj_LB",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_OD_LB[j]/=roi.Num;
		fprintf(fp_o,"\t%f",Ave_OD_LB[j]);
	}
	fprintf(fp_o,"\n");

	// ***************************   L*a*b*l̏o     ***********************************
	fprintf(fp_l,"%s",fn_ROI);//Fo

	for(k=0;k<xyzfunc.Num;k++){//
		Ave_Lab_LB[k]/=roi.Num;
		fprintf(fp_l,"\t%f",Ave_Lab_LB[k]);//o

	}

	fprintf(fp_l,"\n");//o

	fclose(fp2);
	fclose(fp3);
	fclose(fp5);

	fclose(fp_l);
	fclose(fp_re);
	fclose(fp_o);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void StanDard_ROI_Spect_Dye_LAB_16Dim_NORESI(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_ROI,double *cof,char *WFileName)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//ϐFf
	double *ave_dye;
	ave_dye=dvector(0,dye16.Num);

	//XyNg덷 cXyNg֘A
	
	double *Ave_LB;//ߗ
	double *Ave_OD_LB;//zx

	//************* ߗ ***********************
	Ave_LB=dvector(0,dye16.WL);//LBōč\ꂽXyNg

	//************* zx ***********************
	Ave_OD_LB=dvector(0,dye16.WL);//LBōč\ꂽXyNg

			
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz,*xyz_LB;//XYZl

	xyz=dvector(0,xyzfunc.Num);
	xyz_LB=dvector(0,xyzfunc.Num);
	
	double *lab_LB;//LABl
	double *Ave_Lab_LB;

	lab_LB=dvector(0,xyzfunc.Num);
	Ave_Lab_LB=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	
	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fnd[200],name_dye[200];//̐Ff
	char fnl[200],name_lab[200];//L*a*b*l
	char fna[200],name_ave[200];//
	char fn_Alab[200],name_Avelab[200];//L*a*b*@Kv
	char fn_Resi[200],name_AveResi[200];// spectral transmittance @@Kv
	char fn_OD_Resi[200],name_AveOD_Resi[200];// spectral transmittance @Kv


	sprintf(name_dye,"_Dye%dSTD.txt",dye16.Num);//fp2
	sprintf(name_lab,"_Lab_Dye%dSTD.txt",dye16.Num);//fp3

	sprintf(name_ave,"_ave_Dye%dSTD.txt",dye16.Num);//fp5
	sprintf(name_Avelab,"_ave_Lab_Dye%dSTD.txt",dye16.Num);//fpl
	sprintf(name_AveResi,"_ave_trans_Dye%dSTD.spec",dye16.Num);//fp_re
	sprintf(name_AveOD_Resi,"_ave_OD_Dye%dSTD.spec",dye16.Num);//fp_o

	ReName(WFileName,fnd,name_dye);
	ReName(WFileName,fnl,name_lab);

	ReName(WFileName,fna,name_ave);

	ReName(WFileName,fn_Alab,name_Avelab);//ρ@l*a*b*l	
	ReName(WFileName,fn_Resi,name_AveResi);//ρ@cXyNg@ߗ
	ReName(WFileName,fn_OD_Resi,name_AveOD_Resi);//ρ@cXyNg zx


	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("Check_ROIdata.xls",&roi);

	FILE *fp2,*fp3,*fp5;
	FILE *fp_l,*fp_re,*fp_o;

	double *dg;
	dg=dvector(0,wimat.BAND);//ϐMl

	if((fp2 = fopen(fnd, "aw")) == NULL ) {//Ffʁ@@u_Dye%d.txtvt@C
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "aw")) == NULL ) {//l*a*b*@_Lab_Dye.txt
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}

	if((fp5 = fopen(fna, "aw")) == NULL ) {//ϐFfʂ̏o@_ave_Dye.txt
		printf("%s I[vG[\n",fna);
		getchar();
		exit(1);
	}

	if((fp_l = fopen(fn_Alab, "aw")) == NULL ) {//_ave_Lab_Dye%d.txt 
		printf("%s I[vG[\n",fn_Alab);
		getchar();
		exit(1);
	}

	if((fp_re = fopen(fn_Resi, "aw")) == NULL ) {// ̕ϓߗ̏o _ave_trans_Dye%d.spec
		printf("%s I[vG[\n",fn_Resi);
		getchar();
		exit(1);
	}

	if((fp_o = fopen(fn_OD_Resi, "aw")) == NULL ) {// ̕ϋzx̏o _ave_OD_Dye%d.spec
		printf("%s I[vG[\n",fn_OD_Resi);
		getchar();
		exit(1);
	}

	fseek(fp2,  0L, SEEK_END);
	printf("t@Cʒu = %ld\n",ftell(fp2));

	if(ftell(fp2)==0){



		fprintf(fp2,"FileName\tDATA\t");
		for(i=0;i<dye16.Num;i++){//FfʎZo
			fprintf(fp2,"DYE%d\t",i+1);
		}
		fprintf(fp2,"\n");

		fprintf(fp3,"FileName\tDATA\t");//l*a*b*@_Lab_Dye.txt
		for(i=0;i<xyzfunc.Num;i++){//FfʎZo
			fprintf(fp3,"LB_Lab%d\t",i+1);
		}
		fprintf(fp3,"\n");


		fprintf(fp5,"FileName\t");//_ave_Dye.txt

		for(i=0;i<dye16.Num;i++){//FfʎZo
			fprintf(fp5,"ave_DYE%d\t",i+1);
		}
		fprintf(fp5,"\n");

		//L*a*b*l _ave_Lab_Dye.txt
		fprintf(fp_l,"FileName\tave_L*_LB\tave_a*_LB\tave_b*_LB\n");
		

		//ώcXyNg̎Zo  ߗ
		fprintf(fp_re,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp_re,"spe%d\t",i+1);
		}
		fprintf(fp_re,"\n");

		//ώcXyNg̎Zo  zx
		fprintf(fp_o,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp_o,"spe%d\t",i+1);
		}
		fprintf(fp_o,"\n");

	}else{


		fprintf(fp2,"\n");
		fprintf(fp3,"\n");


	}

	fseek(fp2,  0L, SEEK_SET);
//	printf("t@Cʒu = %ld\n",ftell(fp));

//****************         @**************************************

	for(j=0;j<dye16.Num;j++){//Ff
			ave_dye[j]=0;
	}

	for(j=0;j<xyzfunc.Num;j++){//Ff
			Ave_Lab_LB[j]=0;
	}

	for(i=0;i<dye16.WL;i++){//residual in transmittance space
		Ave_LB[i]=0;
	}

	for(i=0;i<dye16.WL;i++){//residual in optical density space
		Ave_OD_LB[i]=0;
	}


//*******************       [vJn@**************************************	
	for(int n=0;n<roi.Num;n++){//ROI̐for[v

		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];
		}

		///////////////////////////////////16ԂŒ@Jn/////////////////////////

		for(i=0;i<wimat.BAND;i++){//ߗMlZo
			spec16[i]=dg[i]/wg[i];
		}

		for(i=0;i<wimat.BAND;i++){//zx֕ϊ
			Do_MinusLog10(&spec16[i],&MinusLog10);
		}

		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
			spec16[i]-=Grass16.data[i];
		}

		//*************************       d݌W̓KpɂFfʒ ******************************************************
		fprintf(fp2,"%s\tAdju_DYE",fn_ROI);
		for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
			dye16.vol[j]=0;
			for(i=0;i<dye16.WL;i++){
				dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
			}

			if(dye16.vol[j]>0){// Ffʂ0ȏȂ
				dye16.vol[j]*=cof[j];//d݌WKp
			}
			fprintf(fp2,"\t%f",dye16.vol[j]);
			ave_dye[j]+=dye16.vol[j];
		}
		fprintf(fp2,"\n");

		//************************************************************************

		for(i=0;i<dye16.WL;i++){//LBɊÂĒzx  data[WL][Num]  O.K. 07/05/22
			dye16.LBSpec[i]=0;
			for(j=0;j<dye16.Num;j++){
				dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
			}
		}

		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
			dye16.LBSpec[i]+=Grass16.data[i];//Ffŕ\XyNg
		}

		//*******************   Averaged original and LB and residual in optical density space ***********************
		for(i=0;i<dye16.WL;i++){
			Ave_OD_LB[i]+=dye16.LBSpec[i];
		}
		//*****************************************************************************

		for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
			Do_Minus10Power(&dye16.LBSpec[i],&Minus10Power);
		}

		/// *************        Normalized Square Error  in transmittance space   ******************

		for(i=0;i<dye16.WL;i++){//residual in transmittance space
			Ave_LB[i]+=dye16.LBSpec[i];
		}

		/// *************         LBŕ\ߗ狁߂L*a*b*@                ******************
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz_LB[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz_LB[k]+=StoX[k*wimat.BAND+i]*dye16.LBSpec[i]*wg[i];
			}
		}
		XYZtoLAB(xyz_LB,whi_xyz,lab_LB);
	
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				Ave_Lab_LB[k]+=lab_LB[k];
		}	
	

		/// *************         L*a*b*l̏o@                ******************
		fprintf(fp3,"%s\tLab",fn_ROI);
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"\t%f",lab_LB[k]);
		}
		fprintf(fp3,"\n");//Fo

	}

	// ***************************   ϐFfʂ̏o     ***********************************
	fprintf(fp5,"%s",fn_ROI);//Fo
	for(j=0;j<dye16.Num;j++){//Ff
			ave_dye[j]/=roi.Num;
			fprintf(fp5,"\t%f",ave_dye[j]);
	}
	fprintf(fp5,"\n");

	
	// ***************************   cXyNg̏o   ߗ  ***********************************

	fprintf(fp_re,"%s\tAdj_LB",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_LB[j]/=roi.Num;
		fprintf(fp_re,"\t%f",Ave_LB[j]);
	}
	fprintf(fp_re,"\n");

	// ***************************   cXyNg̏o   zx  ***********************************

	fprintf(fp_o,"%s\tAdj_LB",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_OD_LB[j]/=roi.Num;
		fprintf(fp_o,"\t%f",Ave_OD_LB[j]);
	}
	fprintf(fp_o,"\n");

	// ***************************   L*a*b*l̏o     ***********************************
	fprintf(fp_l,"%s",fn_ROI);//Fo

	for(k=0;k<xyzfunc.Num;k++){//
		Ave_Lab_LB[k]/=roi.Num;
		fprintf(fp_l,"\t%f",Ave_Lab_LB[k]);//o

	}

	fprintf(fp_l,"\n");//o

	fclose(fp2);
	fclose(fp3);
	fclose(fp5);

	fclose(fp_l);
	fclose(fp_re);
	fclose(fp_o);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}
