//#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "memory_allocate.h"
#include "SPECT.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

void Fwrite_SPEC(char *fn,int WL,int Dim,int INTERVAL,double *SPEC)//2006/1/14/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	fprintf(fp,"\t");//Xy[X̏o
	
	for(i=0;i<Dim;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"\n");
	
	for(i=0;i<WL;i+=INTERVAL){
		fprintf(fp,"%d",i+380);//g̏o
		for(j=0;j<Dim;j++){
			fprintf(fp,"\t%e",SPEC[Dim*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}

void Fwrite_SPEC(char *fn,int oINTERVAL,Spec *spe)//2006/1/14/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	fprintf(fp,"\t");//Xy[X̏o
	
	for(i=0;i<spe->Num;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"\n");
	
	for(i=0;i<spe->WL;i+=oINTERVAL){
		fprintf(fp,"%d\t",i+spe->START);//g̏o
		for(j=0;j<spe->Num;j++){
			fprintf(fp,"%f\t",spe->data[spe->Num*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}


Spec SpecGet(char *fn)
{
	FILE *fp;
	Spec spe;
	char ch,temp[200];
	int s=0,nl=0;
	int i,j;

	strcpy(spe.fn,fn);

	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);
	spe.Num=(s+nl)/nl-1;//n񖼂Ăꍇ n񖼂͕K
	spe.WL=nl-1;//n񖼂Ăꍇ n񖼂͕K
	
	printf("%s open\t",spe.fn);
	printf("( %d x %d ) matrix \n",spe.WL,spe.Num);
	
	spe.data=dvector(0,(spe.WL)*(spe.Num));
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<spe.Num;i++){//Dim n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}
	
	for(i=0;i<spe.WL;i++){
		fscanf(fp,"%s",temp);//Num n񖼂ǂݔ΂
		if(i==0)spe.START=atoi(temp);
		if(i==1)spe.INTERVAL=atoi(temp)-spe.START;
		if(i==spe.WL-1)spe.END=atoi(temp);   // 2007/05/16C
		
		for(j=0;j<spe.Num;j++){
			fscanf(fp,"%s",temp);
			spe.data[i*spe.Num+j]=atof(temp);//f[^̓ǂݍ
		}
		
	}
	
	fclose(fp);
	
	return spe;
	
}