// S_CIELAB.cpp : R\[ AvP[ṼGg |Cg`܂B
//
//#include "stdafx.h"
#include<windows.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "DFT.h"
#include "FFT.h"
#include "memory_allocate.h"
#include "Gauss.h"
#include "Palam.h"

#include "svd_v2.h"


#include "math_func.h"
//#include "CRGB.h"
#include "MSI.h"

#include "S_CIELAB.h"


#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

double ViewAngle(int ViewDist,int DispSize,int resolution_x,int resolution_y)
{
	double IPP;// PʃsNZ̒(inch per pixel)
	double DegPerPix;//PʃsNZ1px(degree per pixel)

	IPP = DispSize / sqrt((double)(pow((double)(resolution_x),2.0) + pow((double)(resolution_y),2.0)));
	DegPerPix = atan((double)(IPP/ViewDist)) * (180/PI);

	return DegPerPix;

}

DispPalam ReadDispPalam(char *fn_Display)
{
	DispPalam IKEGAMI;//gog model
	int N_ike=9;
	char temp[100];
	int i;
	FILE *fp;

	if ((fp=fopen(fn_Display,"r"))==NULL) {//t@C摜
		fprintf(stderr,"Error: file open [%s].\n",fn_Display);
		getchar();
		exit(1);
	}
	for(i=0;i<N_ike;i++){//x̓ǂݔ΂
		fscanf(fp,"%s",temp);
	//	printf("%s\n",temp);
	}

	// *****  R profile  ********* //
	fscanf(fp,"%s",temp);
	IKEGAMI.R.GAIN=atof(temp);

	fscanf(fp,"%s",temp);
	IKEGAMI.R.OFFSET=atof(temp);

	fscanf(fp,"%s",temp);
	IKEGAMI.R.GAMMA=atof(temp);

	// *****  G profile  ********* //

	fscanf(fp,"%s",temp);
	IKEGAMI.G.GAIN=atof(temp);

	fscanf(fp,"%s",temp);
	IKEGAMI.G.OFFSET=atof(temp);

	fscanf(fp,"%s",temp);
	IKEGAMI.G.GAMMA=atof(temp);

	// *****  B profile  ********* //
	fscanf(fp,"%s",temp);
	IKEGAMI.B.GAIN=atof(temp);

	fscanf(fp,"%s",temp);
	IKEGAMI.B.OFFSET=atof(temp);

	fscanf(fp,"%s",temp);
	IKEGAMI.B.GAMMA=atof(temp);
	fclose(fp);

	return IKEGAMI;

}

double* ATD_FouierFilter(MixtureGauss *kernel)
{
	int i;
	int N=kernel->FilterSize*2+1;

	double *xr,*xi;
	xr = new double [N];
	xi = new double [N];
	kernel->ps = new double [N];

	for(i=0;i<N;i++){
		xr[i]=kernel->data[i];
		xi[i]=0;
	}

//	FFT1D(kernel->data,imag,1,N);//ǂFFTŏ
	DFT1D(xr,xi,1,N);//́Fxr, xi AóFxr, xi t[GϊXyNg㏑
	PowerSpect(xr,xi,N,kernel->ps);//p[XyNǧvZ
	FImgShift1D(kernel->ps,N);//SOgɂȂ悤ɃVtg

	delete []xr;
	delete []xi;

	return kernel->ps;

}

double* ReNewDataSizeATD(MixtureGauss *kernel,int FilterSizeMax)
{
	int i;
	int NMax = FilterSizeMax*2+1;	
	int Mid = int(NMax/2.0);//Vf[^̒l
	int N,mid_s;	
	double *New_kernel;//Vf[^TCYkernel
	New_kernel = new double [NMax];

	N = kernel->FilterSize*2+1;
	mid_s = int(N/2.0);//f[^̒l

	for(i=0;i<NMax;i++){
		New_kernel[i]=0;
	}
	if(fmod(double(N),double(2))!=0){
		//***  f[^TCYN̏ꍇ  ***
		for(i=-mid_s;i<mid_s+1;i++){
			New_kernel[i+Mid]=kernel->data[i+mid_s];
		}
	}else{
		//***  f[^TCYN̏ꍇ  ***
		for(i=-mid_s;i<mid_s;i++){
			New_kernel[i+Mid]=kernel->data[i+mid_s];
		}
	}
	kernel->FilterSize = FilterSizeMax;//@tB^[TCY̍XV
	kernel->N = FilterSizeMax*2+1; // ̍XV 
	return New_kernel;
}

void NormalizedATD(MixtureGauss *kernel)
{
	int N,i;
	N=kernel->FilterSize*2+1;//f[^TCY 
	double max=-10000;
	int mid = int(N/2.0);

	for(i=0;i<N;i++){//ől
		if(kernel->ps[i]>=max)max=kernel->ps[i];
	}
	for(i=0;i<N;i++){//őlŋKi
		kernel->ps[i]/=max;
	}
	//0gPɋKi
	kernel->ps[mid]=1;

}

double MakeDegPerPix()
{

	/************************************
	//PʃsNZ1px(degree per pixel)vZ֐

	̃p[^S_CIELAB.hɋLڂB

	************************************/

	double DegPerPix;//PʃsNZ1px(degree per pixel)

	int resolution_x=RESOLUTION_X;
	int resolution_y=RESOLUTION_Y;
	int DispSize = DISPSIZE;// fBXvCTCY (inch)
	int ViewDist = VIEWDIST;// (inch)

	DegPerPix=ViewAngle(ViewDist,DispSize,resolution_x,resolution_y);

	return DegPerPix;

}


double* Read33mat(char *fn_mat)
{
	/************************************
	3~3sǂݍސpvO

	************************************/
	double *mat;
	int N = 3;

	mat = new double [N*N];

	char temp[100];
	int i,j;
	FILE *fp;

	if ((fp=fopen(fn_mat,"r"))==NULL) {//t@CJ
		fprintf(stderr,"Error: file open [%s].\n",fn_mat);
		getchar();
		exit(1);
	}

//	printf("[%s file]\n",fn_mat);
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			fscanf(fp,"%s",temp);
			mat[i*N+j] = atof(temp); 
//			printf("%f\t",mat[i*N+j]);
		}
//		printf("\n");
	}
//	printf("\n");

	return mat;

}

double* MakeRGBtoATD_mat()
{
	/************************************
	3̃t@Cǂݍ݁@RGB @ATD@֕ϊs쐬

	fn_RGBtoXYZ; RGB XYZϊst@C̓ǂݍ
	fn_XYZtoLMS;@XYZ LMSϊst@C̓ǂݍ
	fn_LMStoATD;@LMS ATDϊst@C̓ǂݍ

	S_CIELAB.hwb_[t@C3̃t@CĂB

	j
	#define fn_RGBtoXYZ "..\\Profile_data\\RGBtoXYZ_mat.txt"//RGB_XYZϊsi[Ăt@C
	#define fn_XYZtoLMS "..\\Profile_data\\XYZtoLMS_mat.txt"//XYZ_LMSϊsi[Ăt@C
	#define fn_LMStoATD "..\\Profile_data\\LMStoATD_mat.txt"//LMS_ATDϊsi[Ăt@C


	************************************/

	int i,j,k;
	int N=3;//Number of RGB 
	double *RGBtoXYZ;//RGB XYZϊs
	double *XYZtoLMS;//XYZ LMSϊs
	double *LMStoATD;//LMS ATDϊs

	double *RGBtoLMS;//RGB ATDϊs
	double *RGBtoATD;//RGB ATDϊs

	RGBtoLMS = new double [N*N];
	RGBtoATD = new double [N*N];

	RGBtoXYZ = Read33mat(fn_RGBtoXYZ);// RGB XYZϊst@C̓ǂݍ݁@******************************
	XYZtoLMS = Read33mat(fn_XYZtoLMS);//@XYZ LMSϊst@C̓ǂݍ ******************************
	LMStoATD = Read33mat(fn_LMStoATD);//@LMS ATDϊst@C̓ǂݍ ******************************

	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
				RGBtoLMS[i*N+j] = 0;
				RGBtoATD[i*N+j] = 0;
		}
	}
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			for(k=0;k<N;k++){
				RGBtoLMS[i*N+j] += XYZtoLMS[i*N+k]*RGBtoXYZ[k*N+j]; 	
			}
		}
	}
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			for(k=0;k<N;k++){
				RGBtoATD[i*N+j] += LMStoATD[i*N+k]*RGBtoLMS[k*N+j]; 	
			}
		}
	}

	delete []RGBtoXYZ;
	delete []XYZtoLMS;
	delete []LMStoATD;
	delete []RGBtoLMS;

	return RGBtoATD;

}

double* InvMat33(double *Mat)// ts쐬
{
		/************************************
	R~Rsǂݍ݁@ts쐬

	************************************/

	double *Inv;//ATD RGBϊs (RGB ATDϊs̋ts)
	int N=3;//band of RGB
	Inv = new double [N*N];
	// ATDtoRGB s@= RGBtoATDs̋ts
	svdinv_zeromat1D(Mat,Inv,N,N);

	return Inv;
}

double* MakeATDtoRGB_mat()// ATDRGBϊs쐬
{
		/************************************
	RGBtoATDsǂݍ݁@ATD @RGB@֕ϊs쐬

	************************************/

	double *ATDtoRGB;//ATD RGBϊs (RGB ATDϊs̋ts)
	double *RGBtoATD;
	RGBtoATD=MakeRGBtoATD_mat();
	ATDtoRGB = InvMat33(RGBtoATD);

	delete []RGBtoATD;

	return ATDtoRGB;
}

//double* MakeATDtoRGB_mat(double *RGBtoATD)// ATDRGBϊs쐬
//{
//		/************************************
//	RGBtoATDsǂݍ݁@ATD @RGB@֕ϊs쐬
//
//	************************************/
//
//	double *ATDtoRGB;//ATD RGBϊs (RGB ATDϊs̋ts)
//	int N=3;//band of RGB
//	ATDtoRGB = new double [N*N];
//	// ATDtoRGB s@= RGBtoATDs̋ts
//	svdinv_zeromat1D(RGBtoATD,ATDtoRGB,N,N);
//
//	return ATDtoRGB;
//}

//ATD_IMAGE MakeATDimage(CRGB *rgb,DispPalam *disp,double *RGBtoATD)
//{
//
//	/************************************
//	RGB摜@@ATD摜쐬֐@o͂ATD_IMAGE^
//
//	CRGB *rgb;RGB摜
//	DispPalam *disp;GOGfɎgpp[^^
//	double *RGBtoATD;@RGBATD ϊsi[Ăz
//
//	************************************/
//
//	int x,y,k;
//	int j;
//	int r=0,g=1,b=2;
//
//	double *RGB;
//	ATD_IMAGE ATD;//_u^摜
//	
//	ATD.band = rgb->m_band;
//	ATD.width = rgb->m_width;
//	ATD.height = rgb->m_height;
//	ATD.imgA = new double [ATD.width*ATD.height];
//	ATD.imgT = new double [ATD.width*ATD.height];
//	ATD.imgD = new double [ATD.width*ATD.height];
//
//	RGB = new double [ATD.band];
//	
//	for(y=0;y<rgb->m_height;y++){
//		for(x=0;x<rgb->m_width;x++){
//			
//			for(k=0;k<rgb->m_band;k++){//1ɋKiKv
//				RGB[k]=(double)(rgb->m_data[y*rgb->m_width*rgb->m_band+x*rgb->m_band+k]/255.0);
//			}
//			//      *** GOG model ******    //
//			RGB[r] = pow((disp->R.GAIN*RGB[r]+disp->R.OFFSET),disp->R.GAMMA);
//			RGB[g] = pow((disp->G.GAIN*RGB[g]+disp->G.OFFSET),disp->G.GAMMA);
//			RGB[b] = pow((disp->B.GAIN*RGB[b]+disp->B.OFFSET),disp->B.GAMMA);
//
//			//   *******   ATD image  ******* //
//			ATD.imgA[y*ATD.width+x] = 0;
//			ATD.imgT[y*ATD.width+x] = 0;
//			ATD.imgD[y*ATD.width+x] = 0;
//
//			for(j=0;j<rgb->m_band;j++){
//				ATD.imgA[y*ATD.width+x] += RGBtoATD[r*rgb->m_band+j] * RGB[j];
//				ATD.imgT[y*ATD.width+x] += RGBtoATD[g*rgb->m_band+j] * RGB[j];
//				ATD.imgD[y*ATD.width+x] += RGBtoATD[b*rgb->m_band+j] * RGB[j];
//			}
//
//		}
//	}
//
//	return ATD;
//
//}

unsigned char* MakeRGBimage(ATD_IMAGE *ATD,DispPalam *disp,double *ATDtoRGB)
{

	/************************************
	ATD摜@@RGB摜쐬֐@o͂unsigned char ^

	DIMAGE *ATD;ATD摜
	DispPalam *disp;GOGfɎgpp[^^
	double *ATDtoRGB;@ATDRGB ϊsi[Ăz

	************************************/

	int x,y,k;
	int j;
	int r=0,g=1,b=2;

	double *RGB,*ATDsig;
	unsigned char *RGBimag;
	double max=255,min=0;

	RGB = new double [ATD->band];
	ATDsig = new double [ATD->band];
	RGBimag = new unsigned char [ATD->height*ATD->width*ATD->band];
	
	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){

			ATDsig[r] = ATD->imgA[y*ATD->width+x];
			ATDsig[g] = ATD->imgT[y*ATD->width+x];
			ATDsig[b] = ATD->imgD[y*ATD->width+x];

			for(k=0;k<ATD->band;k++){
				RGB[k] = 0;
				for(j=0;j<ATD->band;j++){
					RGB[k] += ATDtoRGB[k*ATD->band+j] * ATDsig[j];
				}
			}

			// ***     GOG model@ɂoRGBMl쐬 ******    //
			// ::::::::::::    R    :::::::::::::::
			RGB[r] = (pow(RGB[r],(double)1.0/disp->R.GAMMA)-disp->R.OFFSET)/disp->R.GAIN;
			// ::::::::::::    G    :::::::::::::::
			RGB[g] = (pow(RGB[g],(double)1.0/disp->G.GAMMA)-disp->G.OFFSET)/disp->G.GAIN;
			// ::::::::::::    B    :::::::::::::::
			RGB[b] = (pow(RGB[b],(double)1.0/disp->B.GAMMA)-disp->B.OFFSET)/disp->B.GAIN;

			for(k=0;k<ATD->band;k++){//RGBMl255ɋKi
				RGB[k] *=255;
				if(RGB[k]>=max){
					RGBimag[y*ATD->width*ATD->band+x*ATD->band+k]=(unsigned char)max;
				}else if(RGB[k]<=min){
					RGBimag[y*ATD->width*ATD->band+x*ATD->band+k]=(unsigned char)min;
				}else{
					RGBimag[y*ATD->width*ATD->band+x*ATD->band+k]=(unsigned char)RGB[k];
				}
			}

		}
	}

	delete []RGB;
	return RGBimag;
}

unsigned char* COLOR_ATDImage(ATD_IMAGE *ATD)
{
	/************************************
	ATD摜̃J[摜쐬֐@o͂unsigned char ^

	ATD_IMAGE *ATD;ATD摜
	************************************/

	double *ATDsig;
	unsigned char *rgb_data;
	double max=-10000,min=10000;
	int r=0,g=1,b=2;
	int x,y,k;
	ATDsig = new double [ATD->band];
	rgb_data = new unsigned char [ATD->height*ATD->width*ATD->band];
	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){
			ATDsig[r]=ATD->imgA[y*ATD->width+x];
			ATDsig[g]=ATD->imgT[y*ATD->width+x];
			ATDsig[b]=ATD->imgD[y*ATD->width+x];
			//őlAŏlZo
			for(k=0;k<ATD->band;k++){
				if(max<ATDsig[k])
					max=ATDsig[k];
				if(min>ATDsig[k])
					min=ATDsig[k];
			}

		}
	}

	printf("max = %f\tmin = %f\n",max,min);
	printf("tokiya\n");

	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){
			ATDsig[r]=ATD->imgA[y*ATD->width+x];
			ATDsig[g]=ATD->imgT[y*ATD->width+x];
			ATDsig[b]=ATD->imgD[y*ATD->width+x];
			//Ml쐬
			rgb_data[y*ATD->width*ATD->band+x*ATD->band+r]
			= (unsigned char)((ATDsig[r]-min)/(max-min)*255);
			rgb_data[y*ATD->width*ATD->band+x*ATD->band+g]
			= (unsigned char)((ATDsig[g]-min)/(max-min)*255);
			rgb_data[y*ATD->width*ATD->band+x*ATD->band+b]
			= (unsigned char)((ATDsig[b]-min)/(max-min)*255);

		}
	}

	delete []ATDsig;
	return rgb_data;

}

void DoubletoCharImg(double *dimg,int N,unsigned char *out_img)
{
/***********************************************************
		2007/12/14@쐬

		_u摜unsigned char^ɕϊďo͂֐
	
		͉摜 (double^)@摜@dimg[]
		o͉摜 (unsigned char^)  out_img[]
		fF N = Xsize * Ysize * band

*************************************************************/

	int i;
	double max=-10000,min=10000,ave=0;
	double d,di;
	unsigned char c;

	for(i = 0 ; i < N ; i++) {
		if(max<dimg[i])max=dimg[i];
		if(min>dimg[i])min=dimg[i];

		ave+=dimg[i];
	}
	ave/=N;

	for(i = 0 ; i < N ; i++) {
		di = dimg[i];
		d = (di-min)/(max - min);
		c = (unsigned char)(255.0 * d);
		out_img[i] =c;
	}
	
	printf("max=%f\tmin=%f\taverage=%f\n",max,min,ave);

}

void XYZtoLAB(double *xyz,double *wxyz,double *Lab){

	//initialize Lab
	int SpaceDim=3;
	double C[3];

	for(int i=0;i<SpaceDim;i++){
		C[i]=xyz[i]/wxyz[i];
		if(C[i]>0.008856){
			C[i]=pow(C[i],double(1.0/3.0));
		}else{
			C[i]=C[i]*7.787+16.0/116.0;
		}
	}

	Lab[0]=	116*C[1]-16;
	Lab[1]=500*(C[0]-C[1]);
	Lab[2]=200*(C[1]-C[2]);

	//for(int i=0;i<SpaceDim;i++){
	//Lab[i]=0;
	//}
	//if(xyz[0]/wxyz[0]>0.00856)	Lab[0]=	116*pow(xyz[1]/wxyz[1],1.0/3)-16;
	//else Lab[0] = 903.29*(xyz[0]/wxyz[0]);

	//Lab[1]=500*(pow(xyz[0]/wxyz[0],1.0/3)-pow(xyz[1]/wxyz[1],1.0/3));

	//Lab[2]=200*(pow(xyz[1]/wxyz[1],1.0/3)-pow(xyz[2]/wxyz[2],1.0/3));

}

//LAB_IMAGE MakeLABimage(CRGB *rgb,DispPalam *disp)
//{
//	/************************************
//	RGB摜@@ATD摜쐬֐@o͂ATD_IMAGE^
//	CRGB *rgb;RGB摜
//	DispPalam *disp;GOGfɎgpp[^^
//	double *RGBtoATD;@RGBATD ϊsi[Ăz
//	************************************/
//
//	int x,y,k;
//	int j;
//	int r=0,g=1,b=2;
//
//	// RGB XYZϊst@C̓ǂݍ 
//	double *RGBtoXYZ;//RGB XYZϊs
//	RGBtoXYZ = Read33mat(fn_RGBtoXYZ);// @S_CIELAB.hœǂݍ݃t@Cݒ
//
//	LAB_IMAGE LAB;
//	double *RGB,*XYZ,*lab;
//	double wXYZ[]={95.7336,100.4817,110.3641};// wXYZ ͔F_
//
//	LAB.band = rgb->m_band;
//	LAB.width = rgb->m_width;
//	LAB.height = rgb->m_height;
//
//	LAB.data = new double [LAB.width*LAB.height*LAB.band];
//	RGB = new double [rgb->m_band];
//	XYZ = new double [rgb->m_band];
//	lab = new double [rgb->m_band];
//	
//	for(y=0;y<LAB.height;y++){
//		for(x=0;x<LAB.width;x++){
//			for(k=0;k<LAB.band;k++){//1ɋKiKv
//				RGB[k]=(double)(rgb->m_data[y*rgb->m_width*rgb->m_band+x*rgb->m_band+k]/255.0);
//			}
//
//			//      *** GOG model ******    //
//			RGB[r] = pow((disp->R.GAIN*RGB[r]+disp->R.OFFSET),disp->R.GAMMA);
//			RGB[g] = pow((disp->G.GAIN*RGB[g]+disp->G.OFFSET),disp->G.GAMMA);
//			RGB[b] = pow((disp->B.GAIN*RGB[b]+disp->B.OFFSET),disp->B.GAMMA);
//
//			for(k=0;k<LAB.band;k++){
//				XYZ[k]=0;
//			}
//
//			for(k=0;k<LAB.band;k++){
//				for(j=0;j<LAB.band;j++){
//					XYZ[k]+=RGBtoXYZ[k*LAB.band+j]*RGB[j];
//				}
//			}
//
//			XYZtoLAB(XYZ,wXYZ,lab);//XYZLABւ̕ϊ
//
//			for(k=0;k<LAB.band;k++){
//				LAB.data[y*LAB.width*LAB.band+x*LAB.band+k]=lab[k];
//			}
//		}
//	}
//
//	return LAB;
//
//}

double calc_deltaE94(double *lab_r,double *lab_o)
{
	double dL,da,db;
	double dC,C1,C2;
	double dH;
	double Sl,Sc,Sh;
	double dE94;

	dL = sqrt(double(pow(double(lab_r[0]-lab_o[0]),double(2))));
	da = sqrt(double(pow(double(lab_r[1]-lab_o[1]),double(2))));
	db = sqrt(double(pow(double(lab_r[2]-lab_o[2]),double(2))));

	C1 = sqrt(double ( pow(double(lab_r[1]),2.0) + pow(double(lab_r[2]),2.0)));
	C2 = sqrt(double ( pow(double(lab_o[1]),2.0) + pow(double(lab_o[2]),2.0)));
	dC = C1-C2;

	dH = sqrt( pow( da , 2.0) + pow( db , 2.0) - pow( dC , 2.0) );

	Sl = 1;
	Sc = 1 + 0.045 * C1;
	Sh = 1 + 0.015 * C1;

	//Sl = 1;
	//Sc = 1 ;
	//Sh = 1 ;

	dE94 = sqrt( pow( dL/Sl , 2.0 ) + pow( dC/Sc , 2.0) + pow( dH/Sh , 2.0) );

	return dE94;

}

double calc_deltaE(double *lab_r,double *lab_o)
{
	double dL,da,db;
	double dE;

	dL = sqrt(double(pow(double(lab_r[0]-lab_o[0]),double(2))));
	da = sqrt(double(pow(double(lab_r[1]-lab_o[1]),double(2))));
	db = sqrt(double(pow(double(lab_r[2]-lab_o[2]),double(2))));

	dE = sqrt( pow( dL , 2.0 ) + pow( da , 2.0) + pow( db , 2.0) );

	return dE;

}


LAB_IMAGE Make_deltaE94_IMAGE(LAB_IMAGE *ref,LAB_IMAGE *obj)
{
	double *lab_r,*lab_o;
	lab_r = new double [ref->band];
	lab_o = new double [obj->band];

	LAB_IMAGE E94;
	E94.height = ref->height;
	E94.width = ref->width;
	E94.band = 1;
	E94.data = new double [E94.height * E94.width * E94.band];
	E94.max=-10000;
	E94.min=10000;
	E94.ave=0;

	int y,x,k;

	for(y=0;y<ref->height;y++){
		for(x=0;x<ref->width;x++){

			for(k=0;k<ref->band;k++){
				lab_r[k]=ref->data[y*ref->width*ref->band+x*ref->band+k];
				lab_o[k]=obj->data[y*ref->width*ref->band+x*ref->band+k];
			}
			E94.data[y*ref->width + x] = calc_deltaE94(lab_r,lab_o);

			if(E94.data[y*ref->width + x] > E94.max) E94.max = E94.data[y*ref->width + x];
			if(E94.data[y*ref->width + x] < E94.min) E94.min = E94.data[y*ref->width + x];
			
			E94.ave += E94.data[y*ref->width + x];
		}
	}
	E94.ave /=E94.height * E94.width * E94.band;

	return E94;

}

LAB_IMAGE Make_deltaE_IMAGE(LAB_IMAGE *ref,LAB_IMAGE *obj)
{
	double *lab_r,*lab_o;
	lab_r = new double [ref->band];
	lab_o = new double [obj->band];

	LAB_IMAGE E;
	E.height = ref->height;
	E.width = ref->width;
	E.band = 1;
	E.data = new double [E.height * E.width * E.band];

	E.max=-10000;
	E.min=10000;
	E.ave=0;

	int y,x,k;

	for(y=0;y<ref->height;y++){
		for(x=0;x<ref->width;x++){

			for(k=0;k<ref->band;k++){
				lab_r[k]=ref->data[y*ref->width*ref->band+x*ref->band+k];
				lab_o[k]=obj->data[y*ref->width*ref->band+x*ref->band+k];
			}
			E.data[y*ref->width + x] = calc_deltaE(lab_r,lab_o);

			if(E.data[y*ref->width + x] > E.max) E.max = E.data[y*ref->width + x];
			if(E.data[y*ref->width + x] < E.min) E.min = E.data[y*ref->width + x];
			
			E.ave += E.data[y*ref->width + x]/(E.height * E.width * E.band);
		}
	}

	return E;

}

void FilteringATD(ATD_IMAGE *ATD,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
{
	double *imgA_i,*imgT_i,*imgD_i;
	imgA_i = new double [ATD->height*ATD->width];
	imgT_i = new double [ATD->height*ATD->width];
	imgD_i = new double [ATD->height*ATD->width];

	int x,y;

	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){

			imgA_i[y*ATD->width+x] = 0;
			imgT_i[y*ATD->width+x] = 0;
			imgD_i[y*ATD->width+x] = 0;

		}
	}

	FFT2D(ATD->imgA,imgA_i,1,ATD->width,ATD->height);
	FFT2D(ATD->imgT,imgT_i,1,ATD->width,ATD->height);
	FFT2D(ATD->imgD,imgD_i,1,ATD->width,ATD->height);

	FImgShift(ATD->imgA,ATD->width,ATD->height);
	FImgShift(ATD->imgT,ATD->width,ATD->height);
	FImgShift(ATD->imgD,ATD->width,ATD->height);

	FImgShift(imgA_i,ATD->width,ATD->height);
	FImgShift(imgT_i,ATD->width,ATD->height);
	FImgShift(imgD_i,ATD->width,ATD->height);

	int Mx = int(ATD->width/2);
	int My = int(ATD->height/2);
	int gx,gy;

	if(ATD->width%2==0){//摜XTCY̏ꍇ
		gx = 0;
	}else{//̏ꍇ
		gx = 1;
	}

	if(ATD->height%2==0){//摜YTCY̏ꍇ
		gy = 0;
	}else{//̏ꍇ
		gy = 1;
	}

	int mid = kernel_L->FilterSize;//tB^[l
	double freq;//g
	int no_i;//cpdɑΉtB^[f[^z̊蓖Ĕԍ
	double DegPerPix=MakeDegPerPix();//PʃsNZ1px(degree per pixel)

	for(y=-My;y<My+gy;y++){
		for(x=-Mx;x<Mx+gx;x++){
			//g摜̉f(u,v)łcpd
			freq = sqrt(pow((double)(y/(ATD->height*DegPerPix)),2)+pow((double)(x/(ATD->width*DegPerPix)),2));
			//tB^̒S(0g)琔iԖڂłcpd = i*2/(FilterSizeNew*adjust)
			//䂦ɃtB^̒S(0g)琔iԖno_i(u,v)
			//ȉ̂悤ɕ\
			no_i = round(kernel_L->N*adjust*freq*0.5);
			
			ATD->imgA[(y+My)*ATD->width+(x+Mx)] *= kernel_L->ps[no_i+mid];
			ATD->imgT[(y+My)*ATD->width+(x+Mx)] *= kernel_RG->ps[no_i+mid];
			ATD->imgD[(y+My)*ATD->width+(x+Mx)] *= kernel_BY->ps[no_i+mid];

			imgA_i[(y+My)*ATD->width+(x+Mx)] *= kernel_L->ps[no_i+mid];
			imgT_i[(y+My)*ATD->width+(x+Mx)] *= kernel_RG->ps[no_i+mid];
			imgD_i[(y+My)*ATD->width+(x+Mx)] *= kernel_BY->ps[no_i+mid];

		}

	}

	FImgShift(ATD->imgA,ATD->width,ATD->height);
	FImgShift(ATD->imgT,ATD->width,ATD->height);
	FImgShift(ATD->imgD,ATD->width,ATD->height);

	FImgShift(imgA_i,ATD->width,ATD->height);
	FImgShift(imgT_i,ATD->width,ATD->height);
	FImgShift(imgD_i,ATD->width,ATD->height);

	FFT2D(ATD->imgA,imgA_i,-1,ATD->width,ATD->height);
	FFT2D(ATD->imgT,imgT_i,-1,ATD->width,ATD->height);
	FFT2D(ATD->imgD,imgD_i,-1,ATD->width,ATD->height);

	delete []imgA_i;
	delete []imgT_i;
	delete []imgD_i;

}

//unsigned char* ATDFiltering(CRGB *rgb,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
//{
////	char *fn_RGB="img1_0032_704.bmp";
////	char *fn_oRGB="img1_0032_704_filter_ss.bmp";
//	//CRGB rgb;
//	//rgb.readImage(fn_RGB);
//
//	DispPalam disp;//gog model 
//	disp=ReadDispPalam(fn_Disp);// display profile ̓ǂݍ
//
//	double *RGBtoATD;//RGB ATDϊs
//	double *ATDtoRGB;//ATD RGBϊs (RGB ATDϊs̋ts)
//	RGBtoATD = MakeRGBtoATD_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
//	ATDtoRGB = InvMat33(RGBtoATD);
//
//	ATD_IMAGE ATD;//ATD摜̐錾
//	ATD = MakeATDimage(rgb,&disp,RGBtoATD);//	RGB摜@@ATD摜@NƈقȂĂB@C
//
//	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
//
//	rgb->m_data = MakeRGBimage(&ATD,&disp,ATDtoRGB);
//
//	return rgb->m_data;
//
//}


double* MakeXYZtoATD_mat()
{
	/************************************
	2̃t@Cǂݍ݁@XYZ @ATD@֕ϊs쐬

	fn_XYZtoLMS;@XYZ LMSϊst@C̓ǂݍ
	fn_LMStoATD;@LMS ATDϊst@C̓ǂݍ

	S_CIELAB.hwb_[t@C2̃t@CĂB

	j
	#define fn_XYZtoLMS "..\\Profile_data\\XYZtoLMS_mat.txt"//XYZ_LMSϊsi[Ăt@C
	#define fn_LMStoATD "..\\Profile_data\\LMStoATD_mat.txt"//LMS_ATDϊsi[Ăt@C

	************************************/

	int i,j,k;
	int N=3;//Number of RGB 
	double *XYZtoLMS;//XYZ LMSϊs
	double *LMStoATD;//LMS ATDϊs

	double *XYZtoATD;//XYZ ATDϊs
	XYZtoATD = new double [N*N];

	XYZtoLMS = Read33mat(fn_XYZtoLMS);//@XYZ LMSϊst@C̓ǂݍ ******************************
	LMStoATD = Read33mat(fn_LMStoATD);//@LMS ATDϊst@C̓ǂݍ ******************************

	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
				XYZtoATD[i*N+j] = 0;
		}
	}
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			for(k=0;k<N;k++){
				XYZtoATD[i*N+j] += LMStoATD[i*N+k]*XYZtoLMS[k*N+j]; 	
			}
		}
	}

	delete []XYZtoLMS;
	delete []LMStoATD;

	return XYZtoATD;

}

double* MakeATDtoXYZ_mat()
{
	double *XYZtoATD;//RGB ATDϊs
	double *ATDtoXYZ;//ATD RGBϊs (RGB ATDϊs̋ts)
	XYZtoATD = MakeXYZtoATD_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	ATDtoXYZ = InvMat33(XYZtoATD);

	delete []XYZtoATD;

	return ATDtoXYZ;

}


LAB_IMAGE MakeLABimage(ATD_IMAGE *ATD)
{

	/************************************
	ATD摜@@LAB摜쐬֐@o͂́@LAB_IMAGE \́@@S_CIELAB.hŒ`Ă

	ATD_IMAGE *ATD;ATD摜

	************************************/

	int x,y,k;
	int r=0,g=1,b=2;

	// ATD  XYZϊs̍쐬 
	double *ATDtoXYZ;
	ATDtoXYZ = MakeATDtoXYZ_mat();

	LAB_IMAGE LAB;
	double XYZ[3];
	double wXYZ[]={wXYZ_X,wXYZ_Y,wXYZ_Z};// wXYZ ͔F_

	LAB.band = ATD->band;
	LAB.width = ATD->width;
	LAB.height = ATD->height;

	LAB.data = new double [LAB.width*LAB.height*LAB.band];


	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){

			for(k=0;k<ATD->band;k++){
				XYZ[k] = 0;
				XYZ[k] += ATDtoXYZ[k*ATD->band+r] * ATD->imgA[y*ATD->width+x];
				XYZ[k] += ATDtoXYZ[k*ATD->band+g] * ATD->imgT[y*ATD->width+x];
				XYZ[k] += ATDtoXYZ[k*ATD->band+b] * ATD->imgD[y*ATD->width+x];
				
			}
			
/******************************************************************************************************************
			XYZtoLAB(XYZ,wXYZ,lab);//XYZLABւ̕ϊ
			for(k=0;k<LAB.band;k++){
				LAB.data[y*LAB.width*LAB.band+x*LAB.band+k]=lab[k];
			}

			ivOj

			XYZtoLAB(XYZ,wXYZ,&LAB.data[y*LAB.width*LAB.band+x*LAB.band]);


***********************************************************************************************************************/
			XYZtoLAB(XYZ,wXYZ,&LAB.data[y*LAB.width*LAB.band+x*LAB.band]);//XYZLABւ̕ϊ 0.04b@

		}
	}

//	delete []ATDsig;
//	delete []XYZ;

	return LAB;
}

//LAB_IMAGE MakeLABimage_ATDFiltering(CRGB *rgb,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
//{
//	/***********************************************************************************************
//	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
//	RGB摜@@ATDtB^[KpLAB摜쐬֐@
//
//	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
//		@TvOԊuW@double^@adjust
//
//	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă
//
//	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//	*************************************************************************************************/
//	DispPalam disp;//gog model 
//	disp=ReadDispPalam(fn_Disp);// display profile ̓ǂݍ
//
//	double *RGBtoATD;//RGB ATDϊs
//	RGBtoATD = MakeRGBtoATD_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
//
//	//RGB摜ATD摜̐
//	ATD_IMAGE ATD;
//	ATD = MakeATDimage(rgb,&disp,RGBtoATD);//	RGB摜@@ATD摜@NƈقȂĂB@C
//
//	//ATDԂł̃tB^[Kp
//	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
//
//	//ATD摜LAB摜̐
//	LAB_IMAGE LAB;//LAB摜̐錾
//	LAB = MakeLABimage(&ATD);
//
//	delete []ATD.imgA;
//	delete []ATD.imgT;
//	delete []ATD.imgD;
//
//	return LAB;
//
//}

ATD_IMAGE MakeATDimage(MSI *xyz,double *XYZtoATD)
{

	/************************************
	RGB摜@@ATD摜쐬֐@o͂ATD_IMAGE^

	MSI *xyz;XYZ摜
	DispPalam *disp;GOGfɎgpp[^^
	double *XYZtoATD;@XYZATD ϊsi[Ăz

	************************************/

	int x,y;
	int j;
	int r=0,g=1,b=2;
	double cof=100.0/(256*256);

//	double *RGB;
	ATD_IMAGE ATD;//_u^摜
	
	ATD.band = xyz->BAND;
	ATD.width = xyz->X;
	ATD.height = xyz->Y;
	ATD.imgA = new double [ATD.width*ATD.height];
	ATD.imgT = new double [ATD.width*ATD.height];
	ATD.imgD = new double [ATD.width*ATD.height];

	//RGB = new double [ATD.band];
	
	for(y=0;y<ATD.height;y++){
		for(x=0;x<ATD.width;x++){

			//   *******   ATD image  ******* //
			ATD.imgA[y*ATD.width+x] = 0;
			ATD.imgT[y*ATD.width+x] = 0;
			ATD.imgD[y*ATD.width+x] = 0;

			for(j=0;j<ATD.band;j++){
				ATD.imgA[y*ATD.width+x] += double(XYZtoATD[r*ATD.band+j] * xyz->data[y*ATD.width*ATD.band+x*ATD.band+j]*cof);
				ATD.imgT[y*ATD.width+x] += double(XYZtoATD[g*ATD.band+j] * xyz->data[y*ATD.width*ATD.band+x*ATD.band+j]*cof);
				ATD.imgD[y*ATD.width+x] += double(XYZtoATD[b*ATD.band+j] * xyz->data[y*ATD.width*ATD.band+x*ATD.band+j]*cof);
			}

		}
	}

	return ATD;

}

LAB_IMAGE MakeLABimage_ATDFiltering(MSI *xyz,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
{
	/***********************************************************************************************
	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	XYZ摜@@ATDtB^[KpLAB摜쐬֐@

	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
		@TvOԊuW@double^@adjust

	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă

	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	*************************************************************************************************/

	double *XYZtoATD;//RGB ATDϊs
	XYZtoATD = MakeXYZtoATD_mat();// XYZATDϊs쐬

	//RGB摜ATD摜̐
	ATD_IMAGE ATD;
	ATD = MakeATDimage(xyz,XYZtoATD);//	XYZ摜@@ATD摜@

	//ATDԂł̃tB^[Kp
	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);

	//ATD摜LAB摜̐
	LAB_IMAGE LAB;//LAB摜̐錾
	LAB = MakeLABimage(&ATD);

	delete []ATD.imgA;
	delete []ATD.imgT;
	delete []ATD.imgD;

	return LAB;

}

Atd_Filter Make_ATD_FILTER(double adjust)
{
	//	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//**:::::::::     ATDtB^[̍쐬    ::::::::::::::::::::::::::::::::
	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	/***********************************************************************
	ATDtB^[0gSɂ悤ɐݒ

	*************************************************************************/

	//****    ԂłLARGABYtB^[쐬     *******
	Atd_Filter atd;
	atd.kernel_L=MakeMixtureGauss(fn_L,adjust);
	atd.kernel_RG=MakeMixtureGauss(fn_RG,adjust);
	atd.kernel_BY=MakeMixtureGauss(fn_BY,adjust);

	//****    RGABYtB^[̃TCYLtB^[̃TCY֍킹     *******
	int FilterSizeMax = atd.kernel_L.FilterSize;
	if(FilterSizeMax != atd.kernel_RG.FilterSize){
		atd.kernel_RG.data=ReNewDataSizeATD(&atd.kernel_RG,FilterSizeMax);
	}
	if(FilterSizeMax != atd.kernel_BY.FilterSize){
		atd.kernel_BY.data=ReNewDataSizeATD(&atd.kernel_BY,FilterSizeMax);
	}
	//***   t[GԂłLARGABYtB^[̃p[XyNg     *******
	atd.kernel_L.ps=ATD_FouierFilter(&atd.kernel_L);
	atd.kernel_RG.ps=ATD_FouierFilter(&atd.kernel_RG);
	atd.kernel_BY.ps=ATD_FouierFilter(&atd.kernel_BY);

	//***   t[GԂłLARGABYtB^[̋Ki  *******
	NormalizedATD(&atd.kernel_L);
	NormalizedATD(&atd.kernel_RG);
	NormalizedATD(&atd.kernel_BY);

	return atd;

}

unsigned char* MakeRGBimage(UCIMAGE *xyz,DispPalam *disp,double *XYZtoRGB)
{

	/************************************
	xyz摜@@RGB摜쐬֐@o͂unsigned char ^

	UCIMAGE *xyz;xyz摜 (6band摜@XXYYZZ `Ŋi[Ă)
	DispPalam *disp;GOGfɎgpp[^^
	double *XYZtoRGB;@XYZRGB ϊsi[Ăz

	************************************/

	int x,y,k;
	int j;
	int r=0,g=1,b=2;
	int RGBBAND=3;
	double cof=100.0;

	double *RGB;
	double *tp_xyz;
	unsigned char *RGBimag;
	double max=255,min=0;

	RGB = new double [RGBBAND];
	tp_xyz = new double [RGBBAND];
	

	RGBimag = new unsigned char [xyz->Y*xyz->X*RGBBAND];
	
	for(y=0;y<xyz->Y;y++){
		for(x=0;x<xyz->X;x++){
			for(k=0;k<RGBBAND;k++){
				tp_xyz[k] = cof*(xyz->data[(y*xyz->X+x)*xyz->BAND+2*k] + 256.0*xyz->data[(y*xyz->X+x)*xyz->BAND+2*k+1])/65536.0;
		//		tp_xyz[k] = (xyz->data[(y*xyz->X+x)*xyz->BAND+2*k+1]);//{N 
			}

			for(k=0;k<RGBBAND;k++){
				RGB[k] = 0;
				for(j=0;j<RGBBAND;j++){
					RGB[k] += XYZtoRGB[k*RGBBAND+j] *tp_xyz[j];
				}
			}

			// ***     GOG model@ɂoRGBMl쐬 ******    //
			// ::::::::::::    R    :::::::::::::::
			RGB[r] = (pow(RGB[r],(double)1.0/disp->R.GAMMA)-disp->R.OFFSET)/disp->R.GAIN;
			// ::::::::::::    G    :::::::::::::::
			RGB[g] = (pow(RGB[g],(double)1.0/disp->G.GAMMA)-disp->G.OFFSET)/disp->G.GAIN;
			// ::::::::::::    B    :::::::::::::::
			RGB[b] = (pow(RGB[b],(double)1.0/disp->B.GAMMA)-disp->B.OFFSET)/disp->B.GAIN;

			for(k=0;k<RGBBAND;k++){//RGBMl255ɋKi
				RGB[k] *=255;
				if(RGB[k]>=max){
					RGBimag[y*xyz->X*RGBBAND+x*RGBBAND+k]=(unsigned char)max;
				}else if(RGB[k]<=min){
					RGBimag[y*xyz->X*RGBBAND+x*RGBBAND+k]=(unsigned char)min;
				}else{
					RGBimag[y*xyz->X*RGBBAND+x*RGBBAND+k]=(unsigned char)RGB[k];
				}
			}

		}
	}

	delete []RGB;
	return RGBimag;
}

unsigned char* MakeSRGBimage(UCIMAGE *xyz)
{

	/************************************
	XYZ摜@@sRGB摜쐬֐@o͂unsigned char ^

	UCIMAGE *xyz;XYZ摜
	************************************/

	double XYZToBt1361Mat[3][3] = {
		{3.240479, -1.53715, -0.498535},
		{-0.969256, 1.875991, 0.041556},
		{0.055648, -0.204043, 1.057311}
	};

	int x,y,k,l;
	int r=0,g=1,b=2;
	int RGBBAND=3;
	double cof=1.0;


	double *RGB;
	double *tp_xyz;
	unsigned char *RGBimag;
	double max=255,min=0;

	RGB = new double [RGBBAND];
	tp_xyz = new double [RGBBAND];
	
	RGBimag = new unsigned char [xyz->Y*xyz->X*RGBBAND];
	
	for(y=0;y<xyz->Y;y++){
		for(x=0;x<xyz->X;x++){
			for(k=0;k<RGBBAND;k++){
				tp_xyz[k] = cof*(xyz->data[(y*xyz->X+x)*xyz->BAND+2*k] + 256.0*xyz->data[(y*xyz->X+x)*xyz->BAND+2*k+1])/65536.0; 
			}

			for(k=0;k<RGBBAND;k++){
				RGB[k] = 0.0;
				for(l=0; l<RGBBAND; l++){
					RGB[k] = RGB[k] + tp_xyz[l]*XYZToBt1361Mat[k][l];
				}
				if(RGB[k] < 0.0){
					RGB[k] = 0;
				}else if(RGB[k] < 0.018){
					RGB[k] = 4.5*RGB[k];
				}else if(RGB[k]<1.0){
					RGB[k] = 1.099*pow(RGB[k],0.45)-0.099;
				}else{
					RGB[k] = 1.0;
				}
				RGBimag[y*xyz->X*RGBBAND+x*RGBBAND+k]=(unsigned char)(255.0*RGB[k]);
			}

		

		}
	}

	delete []RGB;
	return RGBimag;
}

unsigned char* MakeRGBimage(MSI *xyz,DispPalam *disp,double *XYZtoRGB)
{

	/************************************
	XYZ摜@@RGB摜쐬֐@o͂unsigned char ^

	MSI *XYZ;XYZ摜
	DispPalam *disp;GOGfɎgpp[^^
	double *XYZtoRGB;@XYZRGB ϊsi[Ăz

	unsigned char* MakeRGBimage(UCIMAGE *xyz,DispPalam *disp,double *XYZtoRGB);Ɠ֐

	************************************/

	int x,y,k;
	int j;
	int r=0,g=1,b=2;
	double cof=100.0/(256*256);//XYZtoRGBϊsɂ,XYZ̍ől100ō쐬


	double *RGB;
	double *tp_xyz;
	unsigned char *RGBimag;
	double max=255,min=0;

	RGB = new double [xyz->BAND];
	tp_xyz = new double [xyz->BAND];
	
	
	RGBimag = new unsigned char [xyz->Y*xyz->X*xyz->BAND];
	
	for(y=0;y<xyz->Y;y++){
		for(x=0;x<xyz->X;x++){

			for(k=0;k<xyz->BAND;k++){
				RGB[k] = 0;
				for(j=0;j<xyz->BAND;j++){
					RGB[k] += double(XYZtoRGB[k*xyz->BAND+j] * xyz->data[y*xyz->X*xyz->BAND+x*xyz->BAND+j]*cof);
				}
			}

			// ***     GOG model@ɂoRGBMl쐬 ******    //
			// ::::::::::::    R    :::::::::::::::
			RGB[r] = (pow(RGB[r],(double)1.0/disp->R.GAMMA)-disp->R.OFFSET)/disp->R.GAIN;
			// ::::::::::::    G    :::::::::::::::
			RGB[g] = (pow(RGB[g],(double)1.0/disp->G.GAMMA)-disp->G.OFFSET)/disp->G.GAIN;
			// ::::::::::::    B    :::::::::::::::
			RGB[b] = (pow(RGB[b],(double)1.0/disp->B.GAMMA)-disp->B.OFFSET)/disp->B.GAIN;

			for(k=0;k<xyz->BAND;k++){//RGBMl255ɋKi
				RGB[k] *=255;
				if(RGB[k]>=max){
					RGBimag[y*xyz->X*xyz->BAND+x*xyz->BAND+k]=(unsigned char)max;
				}else if(RGB[k]<=min){
					RGBimag[y*xyz->X*xyz->BAND+x*xyz->BAND+k]=(unsigned char)min;
				}else{
					RGBimag[y*xyz->X*xyz->BAND+x*xyz->BAND+k]=(unsigned char)RGB[k];
				}
			}

		}
	}

	delete []RGB;
	return RGBimag;
}

unsigned char* MakeSRGBimage(MSI *xyz)
{

	/************************************
	XYZ摜@@sRGB摜쐬֐@o͂unsigned char ^

	UCIMAGE *xyz;XYZ摜
	MakeSRGBimage(UCIMAGE *xyz)֐Ɠ
	************************************/

	double XYZToBt1361Mat[3][3] = {
		{3.240479, -1.53715, -0.498535},
		{-0.969256, 1.875991, 0.041556},
		{0.055648, -0.204043, 1.057311}
	};

	int x,y,k,l;
	int r=0,g=1,b=2;
	int RGBBAND=3;
	double cof=1.0/(256*256);//ӁII@sXYZtoRGB̕ϊs͍ől1ɐݒ肵Ă̂


	double *RGB;
	double *tp_xyz;
	unsigned char *RGBimag;
	double max=255,min=0;

	RGB = new double [RGBBAND];
	tp_xyz = new double [RGBBAND];
	
	RGBimag = new unsigned char [xyz->Y*xyz->X*RGBBAND];
	
	for(y=0;y<xyz->Y;y++){
		for(x=0;x<xyz->X;x++){
		
			for(k=0;k<xyz->BAND;k++){
				tp_xyz[k] = xyz->data[y*xyz->X*xyz->BAND+x*xyz->BAND+k]*cof;
			}

			for(k=0;k<RGBBAND;k++){
				RGB[k] = 0.0;
				for(l=0; l<RGBBAND; l++){
					RGB[k] = RGB[k] + tp_xyz[l]*XYZToBt1361Mat[k][l];
				}
				if(RGB[k] < 0.0){
					RGB[k] = 0;
				}else if(RGB[k] < 0.018){
					RGB[k] = 4.5*RGB[k];
				}else if(RGB[k]<1.0){
					RGB[k] = 1.099*pow(RGB[k],0.45)-0.099;
				}else{
					RGB[k] = 1.0;
				}
				RGBimag[y*xyz->X*RGBBAND+x*RGBBAND+k]=(unsigned char)(255.0*RGB[k]);
			}

		}
	}

	delete []RGB;
	return RGBimag;
}

LAB_IMAGE MakeLABimage(MSI *xyz)
{

	/************************************
	XYZ摜@@LAB摜쐬֐@o͂LAB_IMAGE^

	MSI *XYZ;XYZ摜

	************************************/

	int x,y,k;
	int r=0,g=1,b=2;
	double cof=100.0/(256*256);//XYZtoRGBϊsɂ,XYZ̍ől100ō쐬
	double *lab;
	double *tp_xyz;
	//double wXYZ[]={95.7336,100.4817,110.3641};// wXYZ ͔F_
	//0.98697, 1.0, 1.01303
	double wXYZ[]={wXYZ_X,wXYZ_Y,wXYZ_Z};// wXYZ ͔F_


	LAB_IMAGE LAB;

	LAB.band = xyz->BAND;
	LAB.width = xyz->X;
	LAB.height = xyz->Y;

	LAB.data = new double [LAB.width*LAB.height*LAB.band];
	lab = new double [xyz->BAND];
	tp_xyz = new double [xyz->BAND];
	

	for(y=0;y<xyz->Y;y++){
		for(x=0;x<xyz->X;x++){

			for(k=0;k<xyz->BAND;k++){
				tp_xyz[k] = double(xyz->data[y*xyz->X*xyz->BAND+x*xyz->BAND+k]*cof);
			}

			XYZtoLAB(tp_xyz,wXYZ,lab);//XYZLABւ̕ϊ

			for(k=0;k<LAB.band;k++){
				LAB.data[y*LAB.width*LAB.band+x*LAB.band+k]=lab[k];
			}
		

		}
	}

	return LAB;

}

FILE* FOPEN(char *filename, char *mode)
{
	FILE *fp;

	if((fp=fopen(filename,mode))==NULL){
		printf("%s file open error!!\n",filename);
		getchar();
		exit(1);
	}

	return fp;

}

ATD_IMAGE MakeATDimage(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,DispPalam *disp,double *RGBtoATD)
{

	/************************************
	RGB摜@@ATD摜쐬֐@o͂ATD_IMAGE^

	
	DispPalam *disp;GOGfɎgpp[^^
	double *RGBtoATD;@RGBATD ϊsi[Ăz

	************************************/

	int x,y,k;
	int j;
	int r=0,g=1,b=2;
	int RGB_band=3;

	double *RGB;
	ATD_IMAGE ATD;//_u^摜
	
	ATD.band = 3;
	ATD.width =  lppBmpInfo->bmiHeader.biWidth;
	ATD.height = lppBmpInfo->bmiHeader.biHeight;
	ATD.imgA = new double [ATD.width*ATD.height];
	ATD.imgT = new double [ATD.width*ATD.height];
	ATD.imgD = new double [ATD.width*ATD.height];

	RGB = new double [ATD.band];
	
	for(y=0;y<ATD.height;y++){
		for(x=0;x<ATD.width;x++){
			for(k=0;k<RGB_band;k++){//1ɋKiKv
			//	RGB[k]=(double)(rgb->m_data[y*rgb->m_width*rgb->m_band+x*rgb->m_band+k]/255.0);
				 RGB[RGB_band-k-1]=(double)(lpPixel[y*length + x*RGB_band + k]/255.0);
			}
			//      *** GOG model ******    //
			RGB[r] = pow((disp->R.GAIN*RGB[r]+disp->R.OFFSET),disp->R.GAMMA);
			RGB[g] = pow((disp->G.GAIN*RGB[g]+disp->G.OFFSET),disp->G.GAMMA);
			RGB[b] = pow((disp->B.GAIN*RGB[b]+disp->B.OFFSET),disp->B.GAMMA);

			//   *******   ATD image  ******* //
			ATD.imgA[y*ATD.width+x] = 0;
			ATD.imgT[y*ATD.width+x] = 0;
			ATD.imgD[y*ATD.width+x] = 0;

			for(j=0;j<RGB_band;j++){
				ATD.imgA[y*ATD.width+x] += RGBtoATD[r*RGB_band+j] * RGB[j];
				ATD.imgT[y*ATD.width+x] += RGBtoATD[g*RGB_band+j] * RGB[j];
				ATD.imgD[y*ATD.width+x] += RGBtoATD[b*RGB_band+j] * RGB[j];
			}

		}
	}
	delete []RGB;
	return ATD;

}

//LAB_IMAGE MakeLABimage_ATDFiltering(LPBYTE lpPixel,LPBITMAPINFO lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
//{
//	/***********************************************************************************************
//	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
//	RGB摜@@ATDtB^[KpLAB摜쐬֐@
//
//	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
//		@TvOԊuW@double^@adjust
//
//	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă
//
//	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//	*************************************************************************************************/
//	DispPalam disp;//gog model 
//	disp=ReadDispPalam(fn_Disp);// display profile ̓ǂݍ
//
//	double *RGBtoATD;//RGB ATDϊs
//	RGBtoATD = MakeRGBtoATD_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
//
//	//RGB摜ATD摜̐
//	ATD_IMAGE ATD;
////	ATD = MakeATDimage(rgb,&disp,RGBtoATD);//	RGB摜@@ATD摜@NƈقȂĂB@C
//	ATD = MakeATDimage(lpPixel,lppBmpInfo,length,&disp,RGBtoATD);
//
//	//ATDԂł̃tB^[Kp
//	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
//
//	//ATD摜LAB摜̐
//	LAB_IMAGE LAB;//LAB摜̐錾
//	LAB = MakeLABimage(&ATD);
//
//	delete []ATD.imgA;
//	delete []ATD.imgT;
//	delete []ATD.imgD;
//
//	return LAB;
//
//}

void MakeRGBimage(BYTE *lpPixel,ATD_IMAGE *ATD,DispPalam *disp,double *ATDtoRGB)
{

	/************************************
	ATD摜@@RGB摜쐬֐@o͂unsigned char ^

	DIMAGE *ATD;ATD摜
	DispPalam *disp;GOGfɎgpp[^^
	double *ATDtoRGB;@ATDRGB ϊsi[Ăz

	************************************/

	int x,y,k;
	int j;
	int r=0,g=1,b=2;

	double *RGB,*ATDsig;
//	unsigned char *RGBimag;
	double max=255,min=0;

	RGB = new double [ATD->band];
	ATDsig = new double [ATD->band];
//	RGBimag = new BYTE [ATD->height*ATD->width*ATD->band];
	
	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){

			ATDsig[r] = ATD->imgA[y*ATD->width+x];
			ATDsig[g] = ATD->imgT[y*ATD->width+x];
			ATDsig[b] = ATD->imgD[y*ATD->width+x];

			for(k=0;k<ATD->band;k++){
				RGB[k] = 0;
				for(j=0;j<ATD->band;j++){
					RGB[k] += ATDtoRGB[k*ATD->band+j] * ATDsig[j];
				}
			}

			// ***     GOG model@ɂoRGBMl쐬 ******    //
			// ::::::::::::    R    :::::::::::::::
			RGB[r] = (pow(RGB[r],(double)1.0/disp->R.GAMMA)-disp->R.OFFSET)/disp->R.GAIN;
			// ::::::::::::    G    :::::::::::::::
			RGB[g] = (pow(RGB[g],(double)1.0/disp->G.GAMMA)-disp->G.OFFSET)/disp->G.GAIN;
			// ::::::::::::    B    :::::::::::::::
			RGB[b] = (pow(RGB[b],(double)1.0/disp->B.GAMMA)-disp->B.OFFSET)/disp->B.GAIN;

			for(k=0;k<ATD->band;k++){//RGBMl255ɋKi
				RGB[k] *=255;
				if(RGB[k]>=max){
					lpPixel[y*ATD->width*ATD->band+x*ATD->band+ATD->band-k-1]=(BYTE)max;
				}else if(RGB[k]<=min){
					lpPixel[y*ATD->width*ATD->band+x*ATD->band+ATD->band-k-1]=(BYTE)min;
				}else{
					lpPixel[y*ATD->width*ATD->band+x*ATD->band+ATD->band-k-1]=(BYTE)RGB[k];
				}
			}

		}
	}

	delete []RGB;
	//return RGBimag;
}

BYTE* MakeRGBimage_BYTE(ATD_IMAGE *ATD,DispPalam *disp,double *ATDtoRGB)
{

	/************************************
	ATD摜@@RGB摜쐬֐@o͂unsigned char ^

	DIMAGE *ATD;ATD摜
	DispPalam *disp;GOGfɎgpp[^^
	double *ATDtoRGB;@ATDRGB ϊsi[Ăz

	************************************/

	int x,y,k;
	int j;
	int r=0,g=1,b=2;

	double *RGB,*ATDsig;
	BYTE *lpPixel;
	double max=255,min=0;

	RGB = new double [ATD->band];
	ATDsig = new double [ATD->band];
	lpPixel = new BYTE [ATD->height*ATD->width*ATD->band];
	
	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){

			ATDsig[r] = ATD->imgA[y*ATD->width+x];
			ATDsig[g] = ATD->imgT[y*ATD->width+x];
			ATDsig[b] = ATD->imgD[y*ATD->width+x];

			for(k=0;k<ATD->band;k++){
				RGB[k] = 0;
				for(j=0;j<ATD->band;j++){
					RGB[k] += ATDtoRGB[k*ATD->band+j] * ATDsig[j];
				}
			}

			// ***     GOG model@ɂoRGBMl쐬 ******    //
			// ::::::::::::    R    :::::::::::::::
			RGB[r] = (pow(RGB[r],(double)1.0/disp->R.GAMMA)-disp->R.OFFSET)/disp->R.GAIN;
			// ::::::::::::    G    :::::::::::::::
			RGB[g] = (pow(RGB[g],(double)1.0/disp->G.GAMMA)-disp->G.OFFSET)/disp->G.GAIN;
			// ::::::::::::    B    :::::::::::::::
			RGB[b] = (pow(RGB[b],(double)1.0/disp->B.GAMMA)-disp->B.OFFSET)/disp->B.GAIN;

			for(k=0;k<ATD->band;k++){//RGBMl255ɋKi
				RGB[k] *=255;
				if(RGB[k]>=max){
					lpPixel[y*ATD->width*ATD->band+x*ATD->band+ATD->band-k-1]=(BYTE)max;
				}else if(RGB[k]<=min){
					lpPixel[y*ATD->width*ATD->band+x*ATD->band+ATD->band-k-1]=(BYTE)min;
				}else{
					lpPixel[y*ATD->width*ATD->band+x*ATD->band+ATD->band-k-1]=(BYTE)RGB[k];
				}
			}

		}
	}

	delete []RGB;
	return lpPixel;
}

void MakeRGBimage_ATDFiltering(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
{
	/***********************************************************************************************
	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	RGB摜@@ATDtB^[KpLAB摜쐬֐@

	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
		@TvOԊuW@double^@adjust

	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă

	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	*************************************************************************************************/
	DispPalam disp;//gog model 
	disp=ReadDispPalam(fn_Disp);// display profile ̓ǂݍ

	double *RGBtoATD;//RGB ATDϊs
	RGBtoATD = MakeRGBtoATD_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	
	double *ATDtoRGB;//RGB ATDϊs
	ATDtoRGB = MakeATDtoRGB_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬

	//RGB摜ATD摜̐
	ATD_IMAGE ATD;
	ATD = MakeATDimage(lpPixel,lppBmpInfo,length,&disp,RGBtoATD);

	////ATDԂł̃tB^[Kp
	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
	MakeRGBimage(lpPixel,&ATD,&disp,ATDtoRGB);


	delete []ATD.imgA;
	delete []ATD.imgT;
	delete []ATD.imgD;
	
}

BYTE* OutRGBimage_ATDFiltering(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust)
{
	/***********************************************************************************************
	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	RGB摜@@ATDtB^[KpLAB摜쐬֐@

	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
		@TvOԊuW@double^@adjust

	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă

	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	*************************************************************************************************/
	DispPalam disp;//gog model 
	disp=ReadDispPalam(fn_Disp);// display profile ̓ǂݍ

	BYTE *RGB_image;

	double *RGBtoATD;//RGB ATDϊs
	RGBtoATD = MakeRGBtoATD_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	
	double *ATDtoRGB;//RGB ATDϊs
	ATDtoRGB = MakeATDtoRGB_mat();//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬


	//RGB摜ATD摜̐
	ATD_IMAGE ATD;
	ATD = MakeATDimage(lpPixel,lppBmpInfo,length,&disp,RGBtoATD);

	////ATDԂł̃tB^[Kp
	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
	RGB_image = MakeRGBimage_BYTE(&ATD,&disp,ATDtoRGB);


	delete []ATD.imgA;
	delete []ATD.imgT;
	delete []ATD.imgD;
	
	return RGB_image;
	
}

double* MakeRGBtoATD_mat(char *szProfileAdress)
{
	/************************************
	3̃t@Cǂݍ݁@RGB @ATD@֕ϊs쐬

	fn_RGBtoXYZ; RGB XYZϊst@C̓ǂݍ
	fn_XYZtoLMS;@XYZ LMSϊst@C̓ǂݍ
	fn_LMStoATD;@LMS ATDϊst@C̓ǂݍ

	S_CIELAB.hwb_[t@C3̃t@CĂB

	j
	#define fn_RGBtoXYZ "..\\Profile_data\\RGBtoXYZ_mat.txt"//RGB_XYZϊsi[Ăt@C
	#define fn_XYZtoLMS "..\\Profile_data\\XYZtoLMS_mat.txt"//XYZ_LMSϊsi[Ăt@C
	#define fn_LMStoATD "..\\Profile_data\\LMStoATD_mat.txt"//LMS_ATDϊsi[Ăt@C


	************************************/

	char fn_RGBtoXYZ_path[MAX_PATH];
	char fn_XYZtoLMS_path[MAX_PATH];
	char fn_LMStoATD_path[MAX_PATH];

	strcpy(fn_RGBtoXYZ_path,szProfileAdress);
	strcat(fn_RGBtoXYZ_path,fn_RGBtoXYZ);

	strcpy(fn_XYZtoLMS_path,szProfileAdress);
	strcat(fn_XYZtoLMS_path,fn_XYZtoLMS);

	strcpy(fn_LMStoATD_path,szProfileAdress);
	strcat(fn_LMStoATD_path,fn_LMStoATD);

	int i,j,k;
	int N=3;//Number of RGB 
	double *RGBtoXYZ;//RGB XYZϊs
	double *XYZtoLMS;//XYZ LMSϊs
	double *LMStoATD;//LMS ATDϊs

	double *RGBtoLMS;//RGB ATDϊs
	double *RGBtoATD;//RGB ATDϊs

	RGBtoLMS = new double [N*N];
	RGBtoATD = new double [N*N];

	RGBtoXYZ = Read33mat(fn_RGBtoXYZ_path);// RGB XYZϊst@C̓ǂݍ݁@******************************
	XYZtoLMS = Read33mat(fn_XYZtoLMS_path);//@XYZ LMSϊst@C̓ǂݍ ******************************
	LMStoATD = Read33mat(fn_LMStoATD_path);//@LMS ATDϊst@C̓ǂݍ ******************************

	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
				RGBtoLMS[i*N+j] = 0;
				RGBtoATD[i*N+j] = 0;
		}
	}
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			for(k=0;k<N;k++){
				RGBtoLMS[i*N+j] += XYZtoLMS[i*N+k]*RGBtoXYZ[k*N+j]; 	
			}
		}
	}
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			for(k=0;k<N;k++){
				RGBtoATD[i*N+j] += LMStoATD[i*N+k]*RGBtoLMS[k*N+j]; 	
			}
		}
	}

	delete []RGBtoXYZ;
	delete []XYZtoLMS;
	delete []LMStoATD;
	delete []RGBtoLMS;

	return RGBtoATD;

}

double* MakeATDtoRGB_mat(char *szProfileAdress)// ATDRGBϊs쐬
{
		/************************************
	RGBtoATDsǂݍ݁@ATD @RGB@֕ϊs쐬

	************************************/

	double *ATDtoRGB;//ATD RGBϊs (RGB ATDϊs̋ts)
	double *RGBtoATD;
	RGBtoATD=MakeRGBtoATD_mat(szProfileAdress);
	ATDtoRGB = InvMat33(RGBtoATD);

	delete []RGBtoATD;

	return ATDtoRGB;
}

void MakeRGBimage_ATDFiltering_Win(BYTE *lppPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress)
{
	/***********************************************************************************************
	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	RGB摜@@ATDtB^[KpLAB摜쐬֐@

	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
		@TvOԊuW@double^@adjust

	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă

	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	*************************************************************************************************/
	char fn_Disp_path[MAX_PATH];
	strcpy(fn_Disp_path,szProfileAdress);
	strcat(fn_Disp_path,fn_Disp);
	
	DispPalam disp;//gog model 
	disp=ReadDispPalam(fn_Disp_path);// display profile ̓ǂݍ

	double *RGBtoATD;//RGB ATDϊs
	RGBtoATD = MakeRGBtoATD_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	
	double *ATDtoRGB;//RGB ATDϊs
	ATDtoRGB = MakeATDtoRGB_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬

	//RGB摜ATD摜̐
	ATD_IMAGE ATD;
	ATD = MakeATDimage(lppPixel,lppBmpInfo,length,&disp,RGBtoATD);

	////ATDԂł̃tB^[Kp
	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
	MakeRGBimage(lppPixel,&ATD,&disp,ATDtoRGB);


	delete []ATD.imgA;
	delete []ATD.imgT;
	delete []ATD.imgD;
	
}

void MakeRGBimage_ATDFiltering_Win(BYTE *lppPixel_ORI,BYTE *lppPixel_ATD,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress)
{
	/***********************************************************************************************
	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	RGB摜@@ATDtB^[KpLAB摜쐬֐@

	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
		@TvOԊuW@double^@adjust

	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă

	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	*************************************************************************************************/
	char fn_Disp_path[MAX_PATH];
	strcpy(fn_Disp_path,szProfileAdress);
	strcat(fn_Disp_path,fn_Disp);
	
	DispPalam disp;//gog model 
	disp=ReadDispPalam(fn_Disp_path);// display profile ̓ǂݍ

	double *RGBtoATD;//RGB ATDϊs
	RGBtoATD = MakeRGBtoATD_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	
	double *ATDtoRGB;//RGB ATDϊs
	ATDtoRGB = MakeATDtoRGB_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬

	//RGB摜ATD摜̐
	ATD_IMAGE ATD;
	ATD = MakeATDimage(lppPixel_ORI,lppBmpInfo,length,&disp,RGBtoATD);

	////ATDԂł̃tB^[Kp
	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
	MakeRGBimage(lppPixel_ATD,&ATD,&disp,ATDtoRGB);


	delete []ATD.imgA;
	delete []ATD.imgT;
	delete []ATD.imgD;
	
}

Atd_Filter Make_ATD_FILTER_Win_fromFILE(double adjust,char *szProfileAdress)
{
	//	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//**:::::::::     ATDtB^[̍쐬    ::::::::::::::::::::::::::::::::
	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	/***********************************************************************
	ATDtB^[0gSɂ悤ɐݒ

	*************************************************************************/

	char fn_L_path[MAX_PATH];
	char fn_RG_path[MAX_PATH];
	char fn_BY_path[MAX_PATH];


	strcpy(fn_L_path,szProfileAdress);
	strcpy(fn_RG_path,szProfileAdress);
	strcpy(fn_BY_path,szProfileAdress);

	strcat(fn_L_path,fn_L);
	strcat(fn_RG_path,fn_RG);
	strcat(fn_BY_path,fn_BY);


	//****    ԂłLARGABYtB^[쐬     *******
	Atd_Filter atd;
	atd.kernel_L=MakeMixtureGauss(fn_L_path,adjust);
	atd.kernel_RG=MakeMixtureGauss(fn_RG_path,adjust);
	atd.kernel_BY=MakeMixtureGauss(fn_BY_path,adjust);

	//****    RGABYtB^[̃TCYLtB^[̃TCY֍킹     *******
	int FilterSizeMax = atd.kernel_L.FilterSize;
	if(FilterSizeMax != atd.kernel_RG.FilterSize){
		atd.kernel_RG.data=ReNewDataSizeATD(&atd.kernel_RG,FilterSizeMax);
	}
	if(FilterSizeMax != atd.kernel_BY.FilterSize){
		atd.kernel_BY.data=ReNewDataSizeATD(&atd.kernel_BY,FilterSizeMax);
	}
	//***   t[GԂłLARGABYtB^[̃p[XyNg     *******
	atd.kernel_L.ps=ATD_FouierFilter(&atd.kernel_L);
	atd.kernel_RG.ps=ATD_FouierFilter(&atd.kernel_RG);
	atd.kernel_BY.ps=ATD_FouierFilter(&atd.kernel_BY);

	//***   t[GԂłLARGABYtB^[̋Ki  *******
	NormalizedATD(&atd.kernel_L);
	NormalizedATD(&atd.kernel_RG);
	NormalizedATD(&atd.kernel_BY);

	//FLAG_ATD = 1;

	return atd;

}


double* MakeXYZtoATD_mat(char *szProfileAdress)
{
	/************************************
	2̃t@Cǂݍ݁@XYZ @ATD@֕ϊs쐬

	fn_XYZtoLMS;@XYZ LMSϊst@C̓ǂݍ
	fn_LMStoATD;@LMS ATDϊst@C̓ǂݍ

	S_CIELAB.hwb_[t@C2̃t@CĂB

	j
	#define fn_XYZtoLMS "..\\Profile_data\\XYZtoLMS_mat.txt"//XYZ_LMSϊsi[Ăt@C
	#define fn_LMStoATD "..\\Profile_data\\LMStoATD_mat.txt"//LMS_ATDϊsi[Ăt@C

	************************************/

	char fn_XYZtoLMS_path[MAX_PATH];
	char fn_LMStoATD_path[MAX_PATH];

	strcpy(fn_XYZtoLMS_path,szProfileAdress);
	strcat(fn_XYZtoLMS_path,fn_XYZtoLMS);

	strcpy(fn_LMStoATD_path,szProfileAdress);
	strcat(fn_LMStoATD_path,fn_LMStoATD);

	int i,j,k;
	int N=3;//Number of RGB 
	double *XYZtoLMS;//XYZ LMSϊs
	double *LMStoATD;//LMS ATDϊs

	double *XYZtoATD;//XYZ ATDϊs
	XYZtoATD = new double [N*N];

	XYZtoLMS = Read33mat(fn_XYZtoLMS_path);//@XYZ LMSϊst@C̓ǂݍ ******************************
	LMStoATD = Read33mat(fn_LMStoATD_path);//@LMS ATDϊst@C̓ǂݍ ******************************

	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
				XYZtoATD[i*N+j] = 0;
		}
	}
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
			for(k=0;k<N;k++){
				XYZtoATD[i*N+j] += LMStoATD[i*N+k]*XYZtoLMS[k*N+j]; 	
			}
		}
	}

	delete []XYZtoLMS;
	delete []LMStoATD;

	return XYZtoATD;

}

double* MakeATDtoXYZ_mat(char *szProfileAdress)
{
	double *XYZtoATD;//RGB ATDϊs
	double *ATDtoXYZ;//ATD RGBϊs (RGB ATDϊs̋ts)
	XYZtoATD = MakeXYZtoATD_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	ATDtoXYZ = InvMat33(XYZtoATD);

	delete []XYZtoATD;

	return ATDtoXYZ;

}

LAB_IMAGE MakeLABimage_win(ATD_IMAGE *ATD,char *szProfileAdress)
{

	/************************************
	ATD摜@@LAB摜쐬֐@o͂́@LAB_IMAGE \́@@S_CIELAB.hŒ`Ă

	ATD_IMAGE *ATD;ATD摜

	************************************/

	int x,y,k;
	int r=0,g=1,b=2;

	// ATD  XYZϊs̍쐬 
	double *ATDtoXYZ;
	ATDtoXYZ = MakeATDtoXYZ_mat(szProfileAdress);

	LAB_IMAGE LAB;
	double XYZ[3];
	double wXYZ[]={wXYZ_X,wXYZ_Y,wXYZ_Z};// wXYZ ͔F_

	LAB.band = ATD->band;
	LAB.width = ATD->width;
	LAB.height = ATD->height;

	LAB.data = new double [LAB.width*LAB.height*LAB.band];


	for(y=0;y<ATD->height;y++){
		for(x=0;x<ATD->width;x++){

			for(k=0;k<ATD->band;k++){
				XYZ[k] = 0;
				XYZ[k] += ATDtoXYZ[k*ATD->band+r] * ATD->imgA[y*ATD->width+x];
				XYZ[k] += ATDtoXYZ[k*ATD->band+g] * ATD->imgT[y*ATD->width+x];
				XYZ[k] += ATDtoXYZ[k*ATD->band+b] * ATD->imgD[y*ATD->width+x];
				
			}
			
/******************************************************************************************************************
			XYZtoLAB(XYZ,wXYZ,lab);//XYZLABւ̕ϊ
			for(k=0;k<LAB.band;k++){
				LAB.data[y*LAB.width*LAB.band+x*LAB.band+k]=lab[k];
			}

			ivOj

			XYZtoLAB(XYZ,wXYZ,&LAB.data[y*LAB.width*LAB.band+x*LAB.band]);


***********************************************************************************************************************/
			XYZtoLAB(XYZ,wXYZ,&LAB.data[y*LAB.width*LAB.band+x*LAB.band]);//XYZLABւ̕ϊ 0.04b@

		}
	}

//	delete []ATDsig;
//	delete []XYZ;

	return LAB;
}

LAB_IMAGE MakeLABimage_ATDFiltering_Win(BYTE *lppPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,
										MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress)
{
	/***********************************************************************************************
	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	RGB摜@@ATDtB^[KpLAB摜쐬֐@

	́@ATDtB^[g`@MixtureGauss^@kernel_L,kernel_RG,kernel_BY@uGauss.hvŒ`
		@TvOԊuW@double^@adjust

	ó@LAB_IMAGE^ LAB;@@uS_CIELAB.hvŒ`Ă

	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	*************************************************************************************************/

	char fn_Disp_path[MAX_PATH];
	strcpy(fn_Disp_path,szProfileAdress);
	strcat(fn_Disp_path,fn_Disp);
	
	DispPalam disp;//gog model 
	disp=ReadDispPalam(fn_Disp_path);// display profile ̓ǂݍ

	double *RGBtoATD;//RGB ATDϊs
	RGBtoATD = MakeRGBtoATD_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬
	
	double *ATDtoRGB;//RGB ATDϊs
	ATDtoRGB = MakeATDtoRGB_mat(szProfileAdress);//(fn_RGBtoXYZ,fn_XYZtoLMS,fn_LMStoATD);// RGBATDϊs쐬

	//RGB摜ATD摜̐
	ATD_IMAGE ATD;
	ATD = MakeATDimage(lppPixel,lppBmpInfo,length,&disp,RGBtoATD);

	////ATDԂł̃tB^[Kp
	FilteringATD(&ATD,kernel_L,kernel_RG,kernel_BY,adjust);
//	MakeRGBimage(lppPixel,&ATD,&disp,ATDtoRGB);

		//ATD摜LAB摜̐
	LAB_IMAGE LAB;//LAB摜̐錾
	LAB = MakeLABimage_win(&ATD,szProfileAdress);


	delete []ATD.imgA;
	delete []ATD.imgT;
	delete []ATD.imgD;

	return LAB;
	
}

//ATD_IMAGE MakeATDimage(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,DispPalam *disp,double *RGBtoATD)

void DoubleMono_toBYTERGB(double *dimg,int N,unsigned char *out_img)
{
/***********************************************************
		2007/12/14@쐬

		_u摜unsigned char^ɕϊďo͂֐
	
		͉摜 (double^)@摜@dimg[]
		o͉摜 (unsigned char^)  out_img[]
		fF N = Xsize * Ysize * band

*************************************************************/

	int i,k;
	double max=-10000,min=10000,ave=0;
	double d,di;
	unsigned char c;
	int RGB_BAND=3;

	for(i = 0 ; i < N ; i++) {
		if(max<dimg[i])max=dimg[i];
		if(min>dimg[i])min=dimg[i];

		ave+=dimg[i];
	}
	ave/=N;

	for(i = 0 ; i < N ; i++) {
		di = dimg[i];
		d = (di-min)/(max - min);
		c = (unsigned char)(255.0 * d);
		for (k=0;k<RGB_BAND;k++){
			out_img[i*RGB_BAND+k] =c;
		}
	}
	
	//printf("max=%f\tmin=%f\taverage=%f\n",max,min,ave);

}

void S_CIELAB_ColorDiff_win(BYTE *ORI_lppPixel,BYTE *TEST_lppPixel,BYTE *E94_lppPixel,double adjust,
							BITMAPINFO *ORI_lppBmpInfo,int length,Atd_Filter *atd,char *szProfileAdress,LAB_IMAGE *E94_IMAGE)
{
	//ATDtB^[KpLAB摜̍쐬
	LAB_IMAGE LAB,LABt;//LAB摜̐錾
	LAB=MakeLABimage_ATDFiltering_Win(ORI_lppPixel,ORI_lppBmpInfo,length,&atd->kernel_L,
		&atd->kernel_RG,&atd->kernel_BY,adjust,szProfileAdress);

	LABt=MakeLABimage_ATDFiltering_Win(TEST_lppPixel,ORI_lppBmpInfo,length,&atd->kernel_L,
		&atd->kernel_RG,&atd->kernel_BY,adjust,szProfileAdress);

	//************************   CIE DeltaE94F摜̐ƕۑ   ***********************************************
	if(E94_IMAGE != NULL)	delete []E94_IMAGE->data;
	*E94_IMAGE = Make_deltaE94_IMAGE(&LAB,&LABt);//F摜̐idouble^j
	int N = E94_IMAGE->height * E94_IMAGE->width * E94_IMAGE->band;//f錾
//	DoubletoCharImg(E94.data,N,E94_lppPixel);//double^char^֕ϊ
	DoubleMono_toBYTERGB(E94_IMAGE->data,N,E94_lppPixel);


	return;
}
