//char *fn_kernel_L="kernel_L.txt";
//char *fn_kernel_RG="kernel_RG.txt";
//char *fn_kernel_BY="kernel_BY.txt";

#define fn_L "\\kernel_L.txt"//LtB^̃p[^i[Ăt@C
#define fn_RG "\\kernel_RG.txt"//RGtB^̃p[^i[Ăt@C
#define fn_BY "\\kernel_BY.txt"//BYtB^̃p[^i[Ăt@C

#define fn_RGBtoXYZ "\\RGBtoXYZ_mat.txt"//RGB_XYZϊsi[Ăt@C
#define fn_XYZtoLMS "\\XYZtoLMS_mat.txt"//XYZ_LMSϊsi[Ăt@C
#define fn_LMStoATD "\\LMStoATD_mat.txt"//LMS_ATDϊsi[Ăt@C

#define fn_Disp "\\IKEGAMI_parameter.txt"//GOGfɎgpp[^i[Ăt@C
#define fn_CMF "\\SmithPokornyCones.txt"//LMS_ATDϊsi[Ăt@C

#define RESOLUTION_X 1920//\摜X̉f
#define RESOLUTION_Y 1080//\摜X̉f
#define DISPSIZE 14//fBXvCTCY(inchP)
#define VIEWDIST 25//(inchP)
#define wXYZ_X 95.7336// wXYZ ͔F_
#define wXYZ_Y 100.4817
#define wXYZ_Z 110.3641

typedef	struct	ChanelPalam{
	//`lɂGOGfɎgpp[^i[^
	double GAIN;
	double OFFSET;
	double GAMMA;
}ChanelPalam;

typedef	struct	DispPalam{
	//RGBSĂɑ΂GOGfɎgpp[^i[^
	ChanelPalam R;
	ChanelPalam G;
	ChanelPalam B;
}DispPalam;

typedef	struct	DIMAGE{
	// _u^̉摜i[^
	char *fn;
	int width;
	int height;
	int band;
	int SIZE;
	double *data;
}DIMAGE;

typedef	struct	ATD_IMAGE{
	// _u^ATD摜i[^
	char *fn;
	int width;
	int height;
	int band;
	int SIZE;
	double *imgA;
	double *imgT;
	double *imgD;
}ATD_IMAGE;

typedef	struct	LAB_IMAGE{
	// _u^LAB摜i[^
	char *fn;
	int width;
	int height;
	int band;
	int SIZE;
	double *data;
	double ave;
	double max;
	double min;
}LAB_IMAGE;

typedef	struct	Atd_Filter{
	MixtureGauss kernel_L;//LtB^[
	MixtureGauss kernel_RG;//RGtB^[
	MixtureGauss kernel_BY;//BYtB^[
}Atd_Filter;

//pZo֐Q
double ViewAngle(int ViewDist,int DispSize,int resolution_x,int resolution_y);
double MakeDegPerPix();

//t[GԂłATDtB^[Zo֐Q
Atd_Filter Make_ATD_FILTER(double adjust);//ATDtB^[֐
DispPalam ReadDispPalam(char *fn_Display);//fBXvCp[^̓ǂݍ݊֐
double* ATD_FouierFilter(MixtureGauss *kernel);
double* ReNewDataSizeATD(MixtureGauss *kernel,int FilterSizeMax);
void NormalizedATD(MixtureGauss *kernel);


//eϊs𐶐֐Q 
double* MakeRGBtoATD_mat();
double* MakeATDtoRGB_mat();
double* MakeATDtoXYZ_mat();
double* MakeXYZtoATD_mat();

double* MakeRGBtoATD_mat(char *szProfileAdress);
double* MakeATDtoRGB_mat(char *szProfileAdress);




//RGB摜ATD摜@܂́@ATD摜RGB摜@Zo֐Q 
unsigned char* MakeRGBimage(ATD_IMAGE *ATD,DispPalam *disp,double *ATDtoRGB);
BYTE* MakeRGBimage_BYTE(ATD_IMAGE *ATD,DispPalam *disp,double *ATDtoRGB);// for windows
void MakeRGBimage(BYTE *lpPixel,ATD_IMAGE *ATD,DispPalam *disp,double *ATDtoRGB);// for windows
unsigned char* COLOR_ATDImage(ATD_IMAGE *ATD);//ATD摜̃J[
ATD_IMAGE MakeATDimage(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,DispPalam *disp,double *RGBtoATD);// for windows


//ATDԂŃtB^O@yс@tB^OLAB摜o͂֐Q 
void FilteringATD(ATD_IMAGE *ATD,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust);
LAB_IMAGE MakeLABimage_ATDFiltering(MSI *xyz,MixtureGauss *kernel_L,
									MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust);

//tB^ORGB摜o͂֐Q for windows
BYTE* OutRGBimage_ATDFiltering(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,
							   MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust);
void MakeRGBimage_ATDFiltering(BYTE *lpPixel,BITMAPINFO *lppBmpInfo,int length,
							   MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust);


//LAB摜Zo֐Q 
void XYZtoLAB(double *xyz,double *wxyz,double *Lab);
LAB_IMAGE MakeLABimage(ATD_IMAGE *ATD);
LAB_IMAGE MakeLABimage(MSI *xyz);

//F܂͐F摜Zo֐Q 
double calc_deltaE94(double *lab_r,double *lab_o);
double calc_deltaE(double *lab_r,double *lab_o);
LAB_IMAGE Make_deltaE94_IMAGE(LAB_IMAGE *ref,LAB_IMAGE *obj);
LAB_IMAGE Make_deltaE_IMAGE(LAB_IMAGE *ref,LAB_IMAGE *obj);

//̑̊֐Q@{Z摜@Ɋւ 
void DoubletoCharImg(double *dimg,int N,unsigned char *out_img);
double* InvMat33(double *Mat);
double* Read33mat(char *fn_mat);

//RGB摜Zo֐Q (ȉ̓̊֐͓ʂo͂)
unsigned char* MakeRGBimage(UCIMAGE *xyz,DispPalam *disp,double *XYZtoRGB);//ǂݍނƂ8bit6oh摜
unsigned char* MakeRGBimage(MSI *xyz,DispPalam *disp,double *XYZtoRGB);//ǂݍނƂ16bit3oh摜
//sRGB摜Zo֐Q (ȉ̓̊֐͓ʂo͂)
unsigned char* MakeSRGBimage(UCIMAGE *xyz);//ǂݍނƂ8bit6oh摜
unsigned char* MakeSRGBimage(MSI *xyz);//ǂݍނƂ16bit3oh摜

//FILE
FILE* FOPEN(char *filename, char *mode);


//Windows ֌W
double* MakeRGBtoATD_mat(char *szProfileAdress);
double* MakeATDtoRGB_mat(char *szProfileAdress);
void MakeRGBimage_ATDFiltering_Win(BYTE *lppPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress);
void MakeRGBimage_ATDFiltering_Win(BYTE *lppPixel_ORI,BYTE *lppPixel_ATD,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress);

//void READ_ATD_FILTER_Win(HWND hDlg,Atd_Filter *atd,double adjust,char *szProfileAdress);
Atd_Filter Make_ATD_FILTER_Win_fromFILE(double adjust,char *szProfileAdress);
void MakeRGBimage_ATDFiltering_Win(BYTE *lppPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,
								   MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress);
void MakeRGBimage_ATDFiltering_Win(BYTE *lppPixel_ORI,BYTE *lppPixel_ATD,BITMAPINFO *lppBmpInfo,int length,
								   MixtureGauss *kernel_L,MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress);
Atd_Filter Make_ATD_FILTER_Win_fromFILE(double adjust,char *szProfileAdress);
double* MakeXYZtoATD_mat(char *szProfileAdress);
double* MakeATDtoXYZ_mat(char *szProfileAdress);
LAB_IMAGE MakeLABimage_win(ATD_IMAGE *ATD,char *szProfileAdress);
LAB_IMAGE MakeLABimage_ATDFiltering_Win(BYTE *lppPixel,BITMAPINFO *lppBmpInfo,int length,MixtureGauss *kernel_L,
										MixtureGauss *kernel_RG,MixtureGauss *kernel_BY,double adjust,char *szProfileAdress);
void DoubleMono_toBYTERGB(double *dimg,int N,unsigned char *out_img);
void S_CIELAB_ColorDiff_win(BYTE *ORI_lppPixel,BYTE *TEST_lppPixel,BYTE *E94_lppPixel,double adjust,
							BITMAPINFO *ORI_lppBmpInfo,int length,Atd_Filter *atd,char *szProfileAdress,LAB_IMAGE *E94_IMAGE);

