//#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "memory_allocate.h"
#include "Table.h"


double *DataGet(char *fn,int *Num,int *Dim)
{//Table(Num*Dim)
	FILE *fp;
	char ch,temp[200];
	int nl=0,s=0;
	int i,j;
	double *TABLE;
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);
	
	*Dim=(s+nl)/nl-1;//n񖼂Ăꍇ n񖼂͕K
	*Num=nl-1;//n񖼂Ăꍇ n񖼂͕K
	printf("%s open !!\t",fn);
	printf("(%d  X  %d  )\n",*Num,*Dim);
	
	TABLE=dvector(0,(*Dim)*(*Num));
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<(*Dim);i++){//Dim n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}
	
	for(i=0;i<(*Num);i++){
		fscanf(fp,"%s",temp);//Num n񖼂ǂݔ΂
		
		for(j=0;j<(*Dim);j++){
			fscanf(fp,"%s",temp);
			TABLE[i*(*Dim)+j]=atof(temp);//f[^̓ǂݍ
		}
		
	}
	
	fclose(fp);
	
	return TABLE;
	
}

int *DataiGet(char *fn,int *Num,int *Dim)
{//Table(Num*Dim)
	FILE *fp;
	char ch,temp[200];
	int nl=0,s=0;
	int i,j;
	int *TABLE;
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);
	
	*Dim=(s+nl)/nl-1;//n񖼂Ăꍇ n񖼂͕K
	*Num=nl-1;//n񖼂Ăꍇ n񖼂͕K
	//printf("Number of Data = %d\n",*Num);
	//printf("Dimension of Data = %d\n",*Dim);

	printf("%s open !!\t",fn);
	printf("(%d  X  %d  )\n",*Num,*Dim);

	
	TABLE=ivector(0,(*Dim)*(*Num));
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<(*Dim);i++){//Dim n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}
	
	for(i=0;i<(*Num);i++){
		fscanf(fp,"%s",temp);//Num n񖼂ǂݔ΂
		
		for(j=0;j<(*Dim);j++){
			fscanf(fp,"%s",temp);
			TABLE[i*(*Dim)+j]=atoi(temp);//f[^̓ǂݍ
		}
		
	}
	
	fclose(fp);
	
	return TABLE;
	
}

void TableGetInfo(char *fn,int *Num,int *Dim)
{
	FILE *fp;
	char ch;
	int nl=0,s=0;

	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);

	*Dim=(s+nl)/nl;
	*Num=nl-1;//n񖼂Ăꍇ n񖼂͕K
	printf("Dimension of Data = %d\n",*Dim);
	printf("Number of Data = %d\n",*Num);

}

void TableGetInfo_LABEL(char *fn,int *Num,int *Dim)
{//x̃f[^e[u͂ꍇ
	FILE *fp;
	char ch;
	int nl=0,s=0;

	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);

	*Dim=((s+nl)/nl)-1;//x̎iPj͎Dim
	*Num=nl-1;//n񖼂Ăꍇ n񖼂͕K
	printf("Dimension of Data = %d\n",*Dim);
	printf("Number of Data = %d\n",*Num);

}


void TableGet(char *fn,int Num,int Dim, double *TABLE)
{
	FILE *fp;
	char temp[100];
	int i;

	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<Dim;i++){//n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}

	i=0;
	while(fscanf(fp,"%s",temp)!=EOF){
		TABLE[i]=atof(temp);//f[^̓ǂݍ
		i++;
	}
	fclose(fp);


}

void TableGet_LABEL(char *fn,int Num,int Dim, int *Num_LB,int *LABEL,double *TABLE)
{//xĂꍇ
	FILE *fp;
	char temp[100],str[200];
	int i,j;

	strcpy(str,"");

	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<Dim;i++){//n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}
	fscanf(fp,"%s",temp);//x
	
	*Num_LB=0;

	for(i=0;i<Num;i++){
		for(j=0;j<Dim;j++){
			fscanf(fp,"%s",temp);
			TABLE[i*Dim+j]=atof(temp);//f[^̓ǂݍ
		}
		fscanf(fp,"%s",temp);//x̓ǂݍ
		if(strstr(str,temp)==NULL){//ǂݍ񂾃xԍn߂Ă̏ꍇNULL
			strcat(str,temp);
			strcat(str,",");
			*Num_LB=*Num_LB+1;
		}
		LABEL[i]=atoi(temp);
		
	}

	printf("Number of Class = %d\n",*Num_LB);

}

void Fwrite_LTABLE(char *fn,int Num,int Dim,int *LABEL,double *TABLE)
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<Dim;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"LABEL\n");//"LABEL"̏o
	for(i=0;i<Num;i++){
		for(j=0;j<Dim;j++){
			fprintf(fp,"%f\t",TABLE[Dim*i+j]);
		}
		fprintf(fp,"%d\n",LABEL[i]);
	}
	fclose(fp);

}

void Fwrite_TABLE(char *fn,int Num,int Dim,double *TABLE)//bag 2006/12/10/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<Dim;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"\n");

	for(i=0;i<Num;i++){
		for(j=0;j<Dim;j++){
			fprintf(fp,"%e\t",TABLE[Dim*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}

void Fwrite_TABLE_TF(char *fn,int Num,int Dim,double *TABLE)//bag 2006/12/10/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<Num;i++){//n񖼂̏o
		fprintf(fp,"Num%d\t",i+1);
	}
	fprintf(fp,"\n");

	for(j=0;j<Dim;j++){
		for(i=0;i<Num;i++){	
			fprintf(fp,"%e\t",TABLE[Dim*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}

void Fwrite_TABLE(char *fn,int Num,int Dim,unsigned short int *TABLE)//bag 2006/12/10/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<Dim;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"\n");

	for(i=0;i<Num;i++){
		for(j=0;j<Dim;j++){
			fprintf(fp,"%d\t",TABLE[Dim*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}

void Fwrite_TABLE(char *fn,int Num,int Dim,unsigned char *TABLE)//bag 2006/12/10/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<Dim;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"\n");

	for(i=0;i<Num;i++){
		for(j=0;j<Dim;j++){
			fprintf(fp,"%d\t",TABLE[Dim*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}

void ReName(char *fn,char *Refn,char *name)
{
	char *p;
	int c='.';
	int i;

	p = strrchr(fn,c);
	for(i=0;i<p-fn;i++){
		Refn[i]=fn[i];
	}
	Refn[i]='\0';

	strcat(Refn,name);

}
void ReSTDName(char *fn_Osig,char *fn_Rsig,char *Refn,char *name)
{
	char *p;
	char tfn[200];
	int c='.';
	int i;

	p = strrchr(fn_Osig,c);
	for(i=0;i<p-fn_Osig;i++){
		Refn[i]=fn_Osig[i];
	}
	Refn[i]='\0';

	p = strrchr(fn_Rsig,c);
	for(i=0;i<p-fn_Rsig;i++){
		tfn[i]=fn_Rsig[i];
	}
	tfn[i]='\0';

	strcat(Refn,tfn);
	strcat(Refn,name);

}

void Fwrite_TF(char *fn,int Dim,int Num)//Write transformed data in read file Dim * Num >> Num * Dim  
{
	FILE *fp;
	int i,j;
	double *Data;
	char fn_w[200],temp[100];
	ReName(fn,fn_w,"_tr.txt");

	printf("Out File is %s\n",fn_w);
	
	Data=dvector(0,Num*Dim);
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	for(i=0;i<Num*Dim;i++) 
	{		
		fscanf(fp,"%s",temp);
		Data[i]=atof(temp);
	}
	fclose(fp);
	
	
	if((fp=fopen(fn_w,"w"))==NULL){
		printf("%s file open error!!\n",fn_w);
		getchar();
		exit(1);
	}
	
	for(j=0;j<Num;j++)
	{		
		for(i=0;i<Dim;i++){
			fprintf(fp,"%f\t",Data[i*Num+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
	
	free_dvector(Data,0,Num*Dim);

	printf("(%d x %d) matrix \n",Num,Dim);
	
	
}

void Fwrite_ProfileData(char *fn,int Num,int Dim,double *TABLE)//bag 2006/12/10/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	fprintf(fp,"\t");
	for(i=0;i<Dim;i++){//n񖼂̏o
		if(i==Dim-1){
			fprintf(fp,"Dim%d\n",i+1);
		}
		else{
			fprintf(fp,"Dim%d\t",i+1);
		}
	}
//	fprintf(fp,"\n");

	for(i=0;i<Num;i++){
		fprintf(fp,"Num%d\t",i+1);
		for(j=0;j<Dim;j++){
			if(j==Dim-1){
				fprintf(fp,"%f\n",TABLE[Dim*i+j]);
			}
			else{
				fprintf(fp,"%f\t",TABLE[Dim*i+j]);
			}
		}
		//fprintf(fp,"\n");
	}
	fclose(fp);
}

void ReName_Extraction_ad(char *fn,char *Refn)
{
	char *p;
	int c='\\';

	p = strrchr(fn,c);
	strcpy(Refn, p+1); 
}



void NameJoint(char *fn1,char *fn2,char *Refn,char *name)
{
	char *p;
	int c='.';
	int i;
	char fn[200];

	p = strrchr(fn1,c);
	for(i=0;i<p-fn1;i++){
		fn[i]=fn1[i];
	}
	//fn[i]='_';
	fn[i]='\0';
	strcat(fn,"_JOIN_");

	c='\\';
	p = strrchr(fn2,c);
	strcat(fn,p+1);

	ReName(fn,Refn,name);
}

Table DataGet(char *fn)
{//Table(Num*Dim)
	FILE *fp;
	char ch,temp[200];
	int nl=0,s=0;
	int i,j;
	Table TABLE;
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);
	
	TABLE.Dim=(s+nl)/nl-1;//n񖼂Ăꍇ n񖼂͕K
	TABLE.Size=nl-1;//n񖼂Ăꍇ n񖼂͕K
	printf("%s open !!\t",fn);
	printf("(%d  X  %d  )\n",TABLE.Size,TABLE.Dim);
	
	TABLE.data=dvector(0,(TABLE.Dim)*(TABLE.Size));
	TABLE.mean=dvector(0,(TABLE.Dim));
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<(TABLE.Dim);i++){//Dim n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}

	for(j=0;j<(TABLE.Dim);j++){//TABLE.mean̏
		TABLE.mean[j]=0;//
	}

	for(i=0;i<(TABLE.Size);i++){
		fscanf(fp,"%s",temp);//Num n񖼂ǂݔ΂
		
		for(j=0;j<(TABLE.Dim);j++){
			fscanf(fp,"%s",temp);
			TABLE.data[i*(TABLE.Dim)+j]=atof(temp);//f[^̓ǂݍ
			TABLE.mean[j]+=atof(temp);
		}
		
	}	
	fclose(fp);

	for(j=0;j<(TABLE.Dim);j++){//TABLE.mean̏
		TABLE.mean[j]/=TABLE.Size;//
	}
	
	return TABLE;
	
}

void NameJoint_V2(char *fn1,char *fn2,char *Refn,char *name)//dĂ镶āAVt@Cl[쐬
{
	char *p;
	int c='.';
	int i,j;
	char fn[200];

	p = strrchr(fn1,c);
	for(i=0;i<p-fn1;i++){
		Refn[i]=fn1[i];
	}
	Refn[i]='\0';
	strcat(Refn,"&");

	for(i=0;i<200;i++){
		fn[i]='\0';
	}
	j=0;
	while(fn1[j]==fn2[j]){
		j++;
	}

	p = strrchr(fn2,c);
	for(i=j;i<p-fn2;i++){
		fn[i-j]=fn2[i];
	}
	fn[i]='\0';
	strcat(Refn,fn);
	strcat(Refn,name);
	printf("%s\n",Refn);
}
