#include <windows.h>
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "LIB_win.h"
#include "FrameWindow.h"

//	̃EBhEvV[W[
LRESULT CALLBACK LeftChildProc(HWND hChild, UINT msg, WPARAM wp, LPARAM lp)
{
	RECT	rc;
	HDC		hdc;
	PAINTSTRUCT	ps;
	HWND	hParent = GetParent(hChild);
	switch (msg)
	{
	case WM_CREATE:
		{
			CFrameWindow* fwc = (CFrameWindow*)((LPCREATESTRUCT)lp)->lpCreateParams;
			SetWindowLongPtr(hChild,0,TRANS_PTR_CAST(fwc));
		}
        break;
	case WM_PAINT://`揈
		if(m_show == 1)//摜JĂꍇ
		{
			int vis = m_visible;
			if(vis >= m_max)	vis = m_max-1;
			if(width[vis] == 0 || height[vis] == 0)	return (DefWindowProc(hChild, msg, wp, lp));
			hdc=BeginPaint(hChild,&ps);
			{
				GetClientRect(hChild,&rc);
				int w = rc.right-rc.left;
				int h = rc.bottom-rc.top;
				h -= STATUS_H;	if(h < 0)	h = 0;
				if(h-height[vis] <= w-width[vis])	m_ratio=(double)h/(double)height[vis];
				else							m_ratio=(double)w/(double)width[vis];
			}
			if(FLAG_ATD_COLOR == 1)//SCIELABtB^[Kp̃J[摜𐶐Ă邩H
			{
				StretchDIBits(hdc,0,0,(int)(m_ratio*width[vis]),(int)(m_ratio*height[vis]),
					0,0,width[vis],height[vis],lpPixel_ATD[vis],lpBmpInfo[vis],DIB_RGB_COLORS,SRCCOPY);//lpPixel_ATD
			}else{//tB^摜Ȃ
				StretchDIBits(hdc,0,0,(int)(m_ratio*width[vis]),(int)(m_ratio*height[vis]),
					0,0,width[vis],height[vis],lpPixel_ORI[vis],lpBmpInfo[vis],DIB_RGB_COLORS,SRCCOPY);
			}
			CFrameWindow* fwc=(CFrameWindow*)(LONG_PTR)GetWindowLongPtr(hParent,0);
			CHAR chStr[MAX_PATH];
			if( CurX >= width[vis])	CurX=width[vis]-1;
			if( CurY >= height[vis])	CurY=height[vis]-1;
			wsprintf(chStr , " X:%d Y:%d" , CurX,CurY);
			SendMessage(fwc->hLeftChildSt, SB_SETTEXT, 0 | 0, (LPARAM)chStr);
			wsprintf(chStr , " R:%u G:%u B:%u" , lpPixel_ORI[vis][(height[vis]-CurY-1)*length[vis]+CurX*3+2],lpPixel_ORI[vis][(height[vis]-CurY-1)*length[vis]+CurX*3+1],lpPixel_ORI[vis][(height[vis]-CurY-1)*length[vis]+CurX*3]);
			SendMessage(fwc->hLeftChildSt, SB_SETTEXT, 1 | 0, (LPARAM)chStr);
			EndPaint(hChild,&ps);
		}
		return (DefWindowProc(hChild, msg, wp, lp));
	case WM_MOUSEMOVE://}EX@ړ
		if(m_ratio == 0)	break;
		if(m_show == 1)//摜JĂꍇ
		{
			CurX = (unsigned short) (LOWORD(lp)/m_ratio);
			CurY = (unsigned short) (HIWORD(lp)/m_ratio);
			CFrameWindow* fwc=(CFrameWindow*)(LONG_PTR)GetWindowLongPtr(hParent,0);
			InvalidateRect(fwc->hLeftChild , NULL , FALSE);// Xe[^X\XV
			InvalidateRect(fwc->hRightChild , NULL , FALSE);// Xe[^X\XV
			InvalidateRect(fwc->hUnderChild , NULL , FALSE);// Xe[^X\XV
		}
		break;
    default:
        return (DefWindowProc(hChild, msg, wp, lp));
    }
	return 0;
}

//	ẼEBhEvV[W
LRESULT CALLBACK RightChildProc(HWND hChild, UINT msg, WPARAM wp, LPARAM lp)
{
	RECT	rc;
	HDC		hdc;
	PAINTSTRUCT	ps;
	HWND	hParent = GetParent(hChild);
	switch (msg)
	{
	case WM_PAINT://`揈
		if(m_show == 1 && FLAG_FILTER == 1)//򉻉摜JĂ
		{
			int vis = m_visible;
			if(vis >= m_max2)	vis = m_max2-1;
			if(width[vis] == 0 || height[vis] == 0)	return (DefWindowProc(hChild, msg, wp, lp));
			hdc=BeginPaint(hChild,&ps);
			{
				GetClientRect(hChild,&rc);
				int w = rc.right-rc.left;
				int h = rc.bottom-rc.top;
				h -= STATUS_H;	if(h < 0)	h = 0;
				if(h-height[vis] <= w-width[vis])	m_ratio=(double)h/(double)height[vis];
				else							m_ratio=(double)w/(double)width[vis];
				//򉻉摜\
				if(FLAG_ATD_COLOR == 1)//SCIELABtB^[Kp̃J[摜𐶐Ă邩H
				{
					StretchDIBits(hdc,0,0,(int)(m_ratio*width[vis]),(int)(m_ratio*height[vis]),
						0,0,width[vis],height[vis],lpPixel_TEST[vis],lpBmpInfo[vis],DIB_RGB_COLORS,SRCCOPY);
				}else{
					StretchDIBits(hdc,0,0,(int)(m_ratio*width[vis]),(int)(m_ratio*height[vis]),
						0,0,width[vis],height[vis],lpPixel_TEST[vis],lpBmpInfo[vis],DIB_RGB_COLORS,SRCCOPY);
				}
			}
			CFrameWindow* fwc=(CFrameWindow*)(LONG_PTR)GetWindowLongPtr(hParent,0);
			CHAR chStr[MAX_PATH];
			if( CurX >= width[vis])	CurX=width[vis]-1;
			if( CurY >= height[vis])	CurY=height[vis]-1;
			wsprintf(chStr , " X:%d Y:%d" , CurX,CurY);
			SendMessage(fwc->hRightChildSt, SB_SETTEXT, 0 | 0, (LPARAM)chStr);
			wsprintf(chStr , " R:%u G:%u B:%u" , lpPixel_TEST[vis][(height[vis]-CurY-1)*length[vis]+CurX*3+2],lpPixel_TEST[vis][(height[vis]-CurY-1)*length[vis]+CurX*3+1],lpPixel_TEST[vis][(height[vis]-CurY-1)*length[vis]+CurX*3]);
			SendMessage(fwc->hRightChildSt, SB_SETTEXT, 1 | 0, (LPARAM)chStr);
			EndPaint(hChild,&ps);
		}
		return (DefWindowProc(hChild, msg, wp, lp));
	case WM_MOUSEMOVE://}EX@ړ
		if(m_ratio == 0)	break;
		if(m_show == 1)//摜JĂꍇ
		{
			CurX = (unsigned short) (LOWORD(lp)/m_ratio);
			CurY = (unsigned short) (HIWORD(lp)/m_ratio);
			CFrameWindow* fwc=(CFrameWindow*)(LONG_PTR)GetWindowLongPtr(hParent,0);
			InvalidateRect(fwc->hLeftChild , NULL , FALSE);// Xe[^X\XV
			InvalidateRect(fwc->hRightChild , NULL , FALSE);// Xe[^X\XV
			InvalidateRect(fwc->hUnderChild , NULL , FALSE);// Xe[^X\XV
		}
		break;
    default:
	    return (DefWindowProc(hChild, msg, wp, lp));
	}
	return 0;
}
//	̃EBhEvV[W
LRESULT CALLBACK UnderChildProc(HWND hChild, UINT msg, WPARAM wp, LPARAM lp)
{
	RECT	rc;
	HDC		hdc;
	PAINTSTRUCT	ps;
	HWND	hParent = GetParent(hChild);
	switch (msg)
	{
	case WM_PAINT://`揈
		if(m_show == 1 && FLAG_CDIFF > 0)//F摜߂Ă
		{
			int vis = m_visible;
			if(width[vis] == 0 || height[vis] == 0)	return (DefWindowProc(hChild, msg, wp, lp));
			hdc=BeginPaint(hChild,&ps);
			{
				GetClientRect(hChild,&rc);
				int w = rc.right-rc.left;
				int h = rc.bottom-rc.top;
				h -= STATUS_H;	if(h < 0)	h = 0;
				if(h-height[vis] <= w-width[vis])	m_ratio=(double)h/(double)height[vis];
				else							m_ratio=(double)w/(double)width[vis];
				//F}bv\
				StretchDIBits(hdc,0,0,(int)(m_ratio*width[vis]),(int)(m_ratio*height[vis]),
					0,0,width[vis],height[vis],lpPixel_E94[vis],lpBmpInfo[vis],DIB_RGB_COLORS,SRCCOPY);
			}
			CFrameWindow* fwc=(CFrameWindow*)(LONG_PTR)GetWindowLongPtr(hParent,0);
			CHAR chStr[MAX_PATH];
			if( CurX >= width[vis])	CurX=width[vis]-1;
			if( CurY >= height[vis])	CurY=height[vis]-1;
			wsprintf(chStr , " X:%d Y:%d" , CurX,CurY);
			SendMessage(fwc->hUnderChildSt, SB_SETTEXT, 0 | 0, (LPARAM)chStr);
			sprintf(chStr , "Eab:%f" , E94_IMAGE[vis].data[(height[vis]-CurY-1)*width[vis]+CurX]);
			SendMessage(fwc->hUnderChildSt, SB_SETTEXT, 1 | 0, (LPARAM)chStr);
			sprintf(chStr , "S-CIELABF:%f" , E94_IMAGE[vis].ave);
			SendMessage(fwc->hUnderChildSt, SB_SETTEXT, 2 | 0, (LPARAM)chStr);
			EndPaint(hChild,&ps);
		}
		return (DefWindowProc(hChild, msg, wp, lp));
 	case WM_MOUSEMOVE://}EX@ړ
		if(m_ratio == 0)	break;
		if(m_show == 1)//摜JĂꍇ
		{
			CurX = (unsigned short) (LOWORD(lp)/m_ratio);
			CurY = (unsigned short) (HIWORD(lp)/m_ratio);
			CFrameWindow* fwc=(CFrameWindow*)(LONG_PTR)GetWindowLongPtr(hParent,0);
			InvalidateRect(fwc->hLeftChild , NULL , FALSE);// Xe[^X\XV
			InvalidateRect(fwc->hRightChild , NULL , FALSE);// Xe[^X\XV
			InvalidateRect(fwc->hUnderChild , NULL , FALSE);// Xe[^X\XV
		}
		break;
   default:
	    return (DefWindowProc(hChild, msg, wp, lp));
	}
	return 0;
}
