//-------------------------------------------------------------------------------------------------------
// NX CRGB
// RGB摜߂̃NX
// ǂݍ߂摜tH[}bg:bmp
// version 1.05
//-------------------------------------------------------------------------------------------------------

#ifndef _CRGB_H_
#define _CRGB_H_

#include <iostream>


using namespace std;

#define BMP_MODE	0
#define RAW_MODE	1

// ^錾
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;
typedef long                LONG;

// t@Cwb_
typedef struct tagBITMAPFILEHEADER{
    WORD    bfType;
    DWORD   bfSize;
    WORD    bfReserved1;
    WORD    bfReserved2;
    DWORD   bfOffBits;
}BITMAPFILEHEADER;

// wb_(OS/2)
typedef struct tagBITMAPCOREHEADER{
	DWORD	bcSize;
	short	bcWidth;
	short	bcHeight;
	WORD	bcPlanes;
	WORD	buBitCount;
}BITMAPCOREHEADER;

// wb_(Windows)
typedef struct tagBITMAPINFOHEADER{
    DWORD	biSize;
    LONG    biWidth;
    LONG    biHeight;
    WORD    biPlanes;
    WORD    biBitCount;
    DWORD   biCompression;
    DWORD   biSizeImage;
    LONG    biXPelsPerMeter;
    LONG    biYPelsPerMeter;
    DWORD   biClrUsed;
    DWORD   biClrImportant;
}BITMAPINFOHEADER;

// J[pbg(OS/2)
typedef struct tagRGBTRIPLE{
    BYTE    rgbBlue;
    BYTE    rgbGreen;
    BYTE    rgbRed;
}RGBTRIPLE;

// J[pbg(Windows)
typedef struct tagRGBQUAD{
    BYTE    rgbBlue;
    BYTE    rgbGreen;
    BYTE    rgbRed;
    BYTE    rgbReserved;
}RGBQUAD;


// DEBUGp
//#define LS_BMPHEADER 	// wb_̕\


class	CRGB{
	
public:

	// oϐ
	int				m_width;		// 摜̕
	int				m_height;		// 摜̍
	int				m_band;			// 摜̃oh
	int				m_bCnt;			// 1f̃f[^TCY
	int				m_nColors;		// 摜̊K
	RGBQUAD			m_CIdx[256];	// pbgf[^
	unsigned char	*m_data;		// 摜f[^


	// o֐
	explicit CRGB(int w=0, int h=0);	// RXgN^iFCj
	CRGB(int w, int h, int b);			// RXgN^iFCCohj
	CRGB(char *filename);				// RXgN^iFt@Cj
	CRGB(const CRGB &img1);				// Rs[RXgN^
	~CRGB(void);						// fXgN^

	void readImage(char *filename);			// RGB摜ǂݍ݁igp\ȊgqFbmpj
	void writeImage(char *filename);		// RGB摜݁igp\ȊgqFbmpj
	void writeHist(char *filename, int b);	// oh̃qXgOo

	CRGB& getMonoBand(const CRGB &img_in, int b);			// Poh̉摜쐬
	unsigned char getSig(int w, int h, int b);				// f(w,h)boh̐Ml擾
	void setSig(int w, int h, int b, unsigned char sig);	// f(w,h)bohɐMlݒ
	unsigned char getMaxSig(int b);							// oh̍ő̐Ml擾
	unsigned char getMinSig(int b);							// oh̍ŏ̐Ml擾
	unsigned long getSumSig(int b);							// oh̐Ml̑a擾
	double getAveSig(int b);								// oh̐Ml̕ς擾
	double getSDSig(int b);									// oh̐Ml̕U擾
	void resetMemberVariable(int w, int h, int b);			// 摜̕AAohĐݒ

	void printImageInfo(void);	// 摜̕AAoh\

	void smoothing(void);		// tB^
	void reverseColor(void);	// F𔽓]

private:
	void allocateArray(void);	// ̈̊m
	void freeArray(void);		// ̈̊J

	void read_bmp(FILE *fp);							// BMP`ǂݍ
	void read_bmfh(BITMAPFILEHEADER *bmfh, FILE *fp);	// t@Cwb_ǂݍ
	void read_bmih(BITMAPINFOHEADER *bmih, FILE *fp);	// wb_ǂݍ

	void write_bmp(FILE *fp);	// BMP`
	void write_bmfh(FILE *fp);	// t@Cwb_
	void write_bmih(FILE *fp);	// wb_

	void disp_bmfh(BITMAPFILEHEADER bmfh);				// t@Cwb_\
	void disp_bmih(BITMAPINFOHEADER bmih);				// wb_\

	void reverseBandData(void);	// eoh̒ltɓւiBMP̎dl̂߂̊֐j
	void convData(int mem=0);	// 摜f[^_A㌴_ɕבւ
};

#endif
