#define SIGN(a, b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
double pythag(double a, double b);
void nrerror(char *error_text);
float *vector(long nl, long nh);
double *dvector(long start, long end);
unsigned char *ucvector(int start, int end);
unsigned short *usvector(int start, int end);
int *ivector(int start, int end);
double **dpvector(int start, int end);
unsigned char **ucpvector(int start, int end);
int **ipvector(int start, int end);
float **matrix(long nrl, long nrh, long ncl, long nch);
double **dmatrix(long r_start, long r_end, long c_start, long c_end);
double ***dcube(int r_start, int r_end, int c_start, int c_end, int cu_start, int cu_end);
unsigned char ***uccube(int r_start, int r_end, int c_start, int c_end, int cu_start, int cu_end);
double ****d4Darray(int r_start, int r_end, int c_start, int c_end, int cu_start, int cu_end, int D4_start, int D4_end );
unsigned char **ucmatrix(int r_start, int r_end, int c_start, int c_end);
int **imatrix(int r_start, int r_end, int c_start, int c_end);
void free_vector(float *v, long nl, long nh);
void free_dvector(double *v, long nl, long nh);
void free_ivector(int *v, long nl, long nh);
void free_ucvector(unsigned char *v, long nl, long nh);
void free_usvector(unsigned short *v, long nl, long nh);
void free_matrix(float **m, long nrl, long nrh, long ncl, long nch);
void free_dmatrix(double **m, long nrl, long nrh, long ncl, long nch);
void free_ucmatrix(unsigned char **m, long nrl, long nrh, long ncl, long nch);
void free_imatrix(int **m, long nrl, long nrh, long ncl, long nch);
void normalize2(double **before, unsigned char **after, int row, int column, int level);

