// Imspector.cpp : R\[ AvP[ṼGg |Cg`܂B
#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "memory_allocate.h"
#include "MSI.h"
#include "svd_v2.h"
#include "Table.h"
#include "ColorCorrect.h"
#include "SPECT.h"
#include "NaturalVision.h"
#include "kmeans.h"
#include "Dye.h"
#include "compression.h"
#include "Classify.h"
#include "COV.h"
#include "Imspector.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

void IMSPEC_MSI(char *fn_wMSI,char *fn_Imspec)//Imspector̉摜MSIɕϊ (MSIImspector̃t@C)
{
	int i,j,k,x,y;
	char *fn_sys="..\\DATA\\16b.system";

	Wie wimat;
	wimat=Do_WmatIMSPEC(fn_sys,fn_wMSI);//make wieners
	

	//MSI msi;//Multi Spectral Image of object	
	//msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	//msi=MSIGet(msi.fn);

	MSI SPW;
	SPW=MSIGet_V2(fn_Imspec);

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	unsigned short int *g;
	double *dg;

#define RBAND 18
#define DARK 1
#define THROUGH 1

	dg=dvector(0,RBAND);
	g=usvector(0,RBAND);

	FILE *fp2;

	char fnw[200];
	ReName(fn_Imspec,fnw,"_msi.raw");
	printf("%s\n",fnw);

	
	if((fp2 = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}

	int dx=1;// dark current
	int wx=0;// white current
	double d1,d2;
	double *imspe;
	imspe=dvector(0,SPW.BAND);


	for(y=0;y<SPW.Y;y++){
		for(x=0;x<SPW.X;x++){
			for(k=0;k<SPW.BAND;k++){
				d1=(double)(SPW.data[x*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);
				d2=(double)(SPW.data[wx*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);

				if(d2==0){
					imspe[k]=0;
				}else{
					imspe[k]=d1/d2;
				}				
			}
		}
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			if(x>=0&&x<SPW.X&&y>=0&&y<SPW.Y){
				for(k=0;k<SPW.BAND;k++){
					d1=(double)(SPW.data[x*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);
					d2=(double)(SPW.data[wx*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);

					if(d2==0){
						imspe[k]=0;
					}else{
						imspe[k]=d1/d2;
					}				
				}

			}else{
				for(k=0;k<SPW.BAND;k++){
						imspe[k]=0;
				}
			}

			//for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
			//	simSpec[i]=0;
			//}	
			
			g[0]=0;
			for(j=0;j<wimat.BAND;j++){
				dg[j]=0;
				k=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
					//dg[j]+=wimat.tr_H[i*wimat.BAND+j]*simSpec[i];
					dg[j]+=wimat.tr_H[i*wimat.BAND+j]*imspe[k];
					k++;
				}
				g[j+DARK]=(unsigned short int)dg[j];
				//printf("%d\n",g[j+DARK]);
			}
			g[RBAND-THROUGH]=0;

			fwrite(g,sizeof(unsigned short int),RBAND,fp2);

		}

	}


	fclose(fp2);	

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);


}

void IMSPECTraDimg(char *fn)
{

	MSI SPW;
	SPW=MSIGet_V2(fn);

	FILE *fp;
	char fnw[200];

	ReName(fn,fnw,"_dimg.raw");
	printf("Fwite %s \n ",fnw);
	
	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}

	int dx=1;// dark current
	int wx=0;// white current
	double dg,max,min;
	double dg2;

	max=-10000;
	min=10000;

	for(int x=0;x<SPW.X;x++){
		for(int y=0;y<SPW.Y;y++){
			for(int k=0;k<SPW.BAND;k++){
				dg=(double)(SPW.data[x*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);
				dg2=(double)(SPW.data[wx*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);

				if(dg2==0){
					dg=0;
				}else{
					dg/=dg2;
				}				
				if(dg>max){
					max=dg;
				}
				if(dg<min){
					min=dg;
				}
				fwrite(&dg,sizeof(double),1,fp);

			}

		}
	}
	fclose(fp);

	printf("max=%f\tmin=%f\n",max,min);
	free_usvector(SPW.data,0,SPW.BAND*SPW.X*SPW.Y);

}

void GetIMSPEC_SIGNAL(char *fn_Imspec,char *fn_ROI)
{
	int k,x,y,n;

	MSI SPW;
	SPW=MSIGet_V2(fn_Imspec);

	char fnw[200];

	ReName(fn_ROI,fnw,".spec");

	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("test.xls",&roi);

	FILE *fp;
	printf("%s\n",fnw);
	char *fntmp="temporary.txt";
	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}


	//	
	fprintf(fp,"\t");
	for(k=0;k<SPW.BAND;k++){
			fprintf(fp,"Spe%d\t",380+5*k);
	}
	fprintf(fp,"\n");

	int dx=1;// dark current
	int wx=0;// white current
	double d1,d2;
	double *imspe;
	imspe=dvector(0,SPW.BAND);

	for(n=0;n<roi.Num;n++){//ROI̐for[v
		for(k=0;k<SPW.BAND;k++){
			imspe[k]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
				d1=(double)(SPW.data[x*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);
				d2=(double)(SPW.data[wx*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);

				if(d2==0){
					d1=0;
				}else{
					d1/=d2;
				}

				imspe[k]+=d1;
				}
			}
			imspe[k]/=roi.AREA[n];
		}

		fprintf(fp,"data%d\t",n);
		for(k=0;k<SPW.BAND;k++){
			fprintf(fp,"%f\t",imspe[k]);
		}
		fprintf(fp,"\n");

	}
	fclose(fp);

	free_usvector(SPW.data,0,SPW.X*SPW.Y*SPW.BAND);

}

Table GetIMSPEC_Table(char *fn_Imspec,char *fn_ROI)
{
	int k,x,y,n;

	MSI SPW;
	SPW=MSIGet_V2(fn_Imspec);

	ROI roi;
	roi=ROIGet(fn_ROI);

	Table IMSPEC;
	IMSPEC.Size=roi.Num;
	IMSPEC.Dim=SPW.BAND;
	IMSPEC.data=dvector(0,roi.Num*SPW.BAND);
	IMSPEC.mean=dvector(0,SPW.BAND);

	for(k=0;k<SPW.BAND;k++){
		IMSPEC.mean[k]=0;
	}

	int dx=1;// dark current
	int wx=0;// white current
	double d1,d2;
	double *imspe;
	imspe=dvector(0,SPW.BAND);


	for(n=0;n<roi.Num;n++){//ROI̐for[v
		for(k=0;k<SPW.BAND;k++){
			imspe[k]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
				d1=(double)(SPW.data[x*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);
				d2=(double)(SPW.data[wx*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);

				if(d2==0){
					d1=0;
				}else{
					d1/=d2;
				}

				imspe[k]+=d1;
				}
			}
			imspe[k]/=roi.AREA[n];
			IMSPEC.data[SPW.BAND*n+k]=imspe[k];
			IMSPEC.mean[k]+=imspe[k];
		}

	}

	for(k=0;k<SPW.BAND;k++){
		IMSPEC.mean[k]/=IMSPEC.Size;
	}

	free_usvector(SPW.data,0,SPW.X*SPW.Y*SPW.BAND);

	return IMSPEC;

}

COVMAT GetWithin_ClassCovarianceMat_SelectBandIMSPEC(int DIMENSION,int *iwave,COVMAT *cov1,COVMAT *cov2,double P1,double P2)
{//DIMENSIN:Ig̐          iwave:Igi[xNg@
 //cov1,cov2:NX1,2̋Us    P1,P2:NX1,2̎Om 
	int i,j;
	COVMAT W_COV;
	W_COV.Dim=DIMENSION;
	W_COV.data=dvector(0,DIMENSION*DIMENSION);

	for(i=0;i<DIMENSION;i++){//cov1data O.K. !! and cov2-> data O.K. !! 
		for(j=0;j<DIMENSION;j++){
			W_COV.data[DIMENSION*i+j]=P1*cov1->data[cov1->Dim*iwave[i]+iwave[j]]+P2*cov2->data[cov2->Dim*iwave[i]+iwave[j]];
		}
	}
	
	return W_COV;
}

COVMAT GetBetween_ClassCovarianceMat_SelectBandIMSPEC(int DIMENSION,int *iwave,Table *imspe1,Table *imspe2,double P1,double P2)
{//DIMENSIN:Ig̐          iwave:Igi[xNg@
 //imspe1,imspe2:NX1,2̃f[^s    P1,P2:NX1,2̎Om 
	int i,j;
	COVMAT B_COV;
	B_COV.Dim=DIMENSION;
	B_COV.data=dvector(0,DIMENSION*DIMENSION);
	double *mean;
	mean=dvector(0,DIMENSION);

	for(i=0;i<DIMENSION;i++){//σxNg̍쐬
		mean[i]=imspe1->mean[iwave[i]]+imspe2->mean[iwave[i]];
		mean[i]/=2;
	}

	for(i=0;i<DIMENSION;i++){
		for(j=0;j<DIMENSION;j++){
			B_COV.data[DIMENSION*i+j]=0;
		}
	}

	for(i=0;i<DIMENSION;i++){
		for(j=0;j<DIMENSION;j++){
			B_COV.data[DIMENSION*i+j]+=P1*(imspe1->mean[iwave[i]]-mean[i])*(imspe1->mean[iwave[j]]-mean[j]);
		}
	}

	for(i=0;i<DIMENSION;i++){
		for(j=0;j<DIMENSION;j++){
			B_COV.data[DIMENSION*i+j]+=P2*(imspe2->mean[iwave[i]]-mean[i])*(imspe2->mean[iwave[j]]-mean[j]);
		}
	}
	return B_COV;

}

void GetIMSPEC_SIGNAL(MSI *SPW,double *imspe,int *x,int *y)
{
	int k;
	double dg,dg2;
	
	for(k=0;k<SPW->BAND;k++){
		dg=(double)(SPW->data[(*x)*SPW->Y*SPW->BAND+(*y)*SPW->BAND+k]-SPW->data[SPW->IM_dx*SPW->Y*SPW->BAND+(*y)*SPW->BAND+k]);
		dg2=(double)(SPW->data[SPW->IM_wx*SPW->Y*SPW->BAND+(*y)*SPW->BAND+k]-SPW->data[SPW->IM_dx*SPW->Y*SPW->BAND+(*y)*SPW->BAND+k]);

		if(dg2==0){
			dg=0;
		}else{
			dg/=dg2;
		}
		imspe[k]=dg;
	}

}

void NVRGB_Imspec(char *fn_Imspec)
{
	int i,j,k,x,y;

	Wie wimat;
	wimat=Do_WmatIMSPEC();//wieners͍쐬ȂAgohȂǂ̃p[^

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	//***********************   IMSPECTOR ̒`@**********************************************
	MSI SPW;
	SPW=MSIGet_V2(fn_Imspec);//摜IMSPECTOR̓ǂݍ
	
	double *ImSpec401;////Imspector̃XyNg401̔z֊i[
	double *imspe81;//Imspector̃XyNg81̔z֊i[
	
	ImSpec401=dvector(0,wimat.WL);
	imspe81=dvector(0,SPW.BAND);

	//***********************   RGB摜̍쐬t@C@**********************************************
	FILE *fp;
	char fnw[200];

	ReName(fn_Imspec,fnw,"_orirgb.raw");
	printf("Fwite %s \n ",fnw);
	
	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}


	for(x=SPW.IM_sx;x<SPW.X;x++){//SPW.IM_sx=2 摜Ml͂
		for(y=0;y<SPW.Y;y++){

			GetIMSPEC_SIGNAL(&SPW,imspe81,&x,&y);//(x,y)ɂ镪ߗ̎Zo

			//401z֕ߗi[
			k=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//KX̓ߗŊ
				ImSpec401[i]=imspe81[k];///Grass.data[i];
				k++;
			}

			for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				xyz[k]=0;
				for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
					xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*ImSpec401[i];
				}
			}
			for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
				irgb[k]=0;
				for(j=0;j<xyzfunc.Num;j++){
					irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
				}
			}
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml

			fwrite(orgb,sizeof(unsigned char),xyzfunc.Num,fp);

		}
	}
	fclose(fp);


	free_usvector(SPW.data,0,SPW.X*SPW.Y*SPW.BAND);	
	free_dvector(ImSpec401,0,wimat.WL);
	free_dvector(imspe81,0,SPW.BAND);

	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);

}


COVMAT COVMAT_Imspec(char *fn_Imspec)
{
	int i,j,x,y;

	Wie wimat;
	wimat=Do_WmatIMSPEC();//wieners͍쐬ȂAgohȂǂ̃p[^

	//***********************   IMSPECTOR ̒`@**********************************************
	MSI SPW;
	SPW=MSIGet_V2(fn_Imspec);//摜IMSPECTOR̓ǂݍ
	
	double *ImSpec401;////Imspector̃XyNg401̔z֊i[
	double *imspe81;//Imspector̃XyNg81̔z֊i[
	
	ImSpec401=dvector(0,wimat.WL);
	imspe81=dvector(0,SPW.BAND);

	//***********************   Us ̒`@**********************************************
	COVMAT IMCOV;
	IMCOV.Dim=SPW.BAND;//IMSPECTOR̎
	IMCOV.Size=(SPW.X-SPW.IM_sx)*(SPW.Y);//IMSPECTOR摜TCY
	IMCOV.data=dvector(0,IMCOV.Dim*IMCOV.Dim);//Us̔zm

	//Us̏
	for(i=0;i<IMCOV.Dim;i++){
		for(j=0;j<IMCOV.Dim;j++){
			IMCOV.data[i*IMCOV.Dim+j]=0;
		}
	}

	for(x=SPW.IM_sx;x<SPW.X;x++){//SPW.IM_sx=2 摜Ml͂
		for(y=0;y<SPW.Y;y++){

			GetIMSPEC_SIGNAL(&SPW,imspe81,&x,&y);//(x,y)ɂ镪ߗ̎Zo
			//Us̍쐬
			for(i=0;i<IMCOV.Dim;i++){
				for(j=0;j<IMCOV.Dim;j++){
					IMCOV.data[i*IMCOV.Dim+j]+=imspe81[i]*imspe81[j];
				}
			}

		}
	}

	//Us̏
	for(i=0;i<IMCOV.Dim;i++){
		for(j=0;j<IMCOV.Dim;j++){
			IMCOV.data[i*IMCOV.Dim+j]/=IMCOV.Size;
		}
	}

	free_usvector(SPW.data,0,SPW.X*SPW.Y*SPW.BAND);	
	free_dvector(ImSpec401,0,wimat.WL);
	free_dvector(imspe81,0,SPW.BAND);

	return IMCOV;

}

void GetCOVMAT_KL_IMSPEC(char *fn_Imspec)//Imspector摜ǂݍCOVMAT\̏oKL쐬
{
	char fnc[200];//Us̏ot@Ci[z
	char fnk[200];//KL̏ot@Ci[z
	char fne[200];//ŗLl̏ot@Ci[z

	COVMAT IMCOV;
	IMCOV=COVMAT_Imspec(fn_Imspec);//Us̍쐬č\̂֊i[

	ReName(fn_Imspec,fnc,".covmat");//o̓t@C`COVMAT\
	Fwrite_COVData(fnc,&IMCOV);

	double *w,*v;
	w=dvector(0,IMCOV.Dim);
	v=dvector(0,IMCOV.Dim*IMCOV.Dim);

	//KL֐̍쐬
	svdcmp_zeromat1D(IMCOV.data,IMCOV.Dim,IMCOV.Dim,w,v);

	ReName(fn_Imspec,fnk,"_kl.txt");//
	ReName(fn_Imspec,fne,"_eigen.txt");//

	Fwrite_ProfileData(fnk,IMCOV.Dim,IMCOV.Dim,v);
	Fwrite_ProfileData(fne,IMCOV.Dim,1,w);

	free_dvector(w,0,IMCOV.Dim);
	free_dvector(v,0,IMCOV.Dim*IMCOV.Dim);

}

void FILELIST_COVMAT_KL_IMSPEC(char *FileList){//FileListɂImspector摜ǂݍCOVMAT\̏oKL쐬
	
	char fn_Imspec[200];
	FILE *fp_m;
	//t@CXg̓ǂݎ
	if((fp_m=fopen(FileList,"r"))==NULL){
		printf("%s File Open  ERROR 1.1 \n",FileList); getchar() ; exit(1);         } 
	
	while(fscanf(fp_m,"%s",fn_Imspec)!=EOF)//ꃋ[vJnn_ Xy[X鎞ɕSēǂݍ߂Ȃ@"Documents and Settings""Documents"
	{
		GetCOVMAT_KL_IMSPEC(fn_Imspec);//UsKLAŗLlt@CZo

	}

}
