#define iniINTERVAL	5// sampling interval 
#define	iniNLEVEL	1.0E-3//Noise Level
#define	iniSTART	400//start wavelength minimum=380
#define	iniEND	700//end wavelength maximum=780
#define	SimuWhite	60000//end wavelength
#define SELCOV 1//'1' use priori information, '0' use marcov covariance matrix  
#define	iniProb	0.999//end wavelength maximum=780

typedef	struct	Wie{
	int START;
	int END;
	int	WL;//Dimension of wave length
	int BAND;//Number of Band
	int INTERVAL;// unit is "nm"
	double NLEVEL;// Noise Level
	double *tr_H;//SYSTEM MATRIX
	double *Cov;//Covriance Matrix obtained by TraSpec
	double *mat;
}Wie;
typedef	struct	Disp{
	char fn[200];
	Spec	primary;
	double *XtoD;// from XYZ to Disp
	double *DtoX;// from Disp to XYZ
	double *back;
}Disp;
typedef	struct	Tone{
	char fn[200];
	int	STEP;//Signal step
	int RGB;//Number of RGB
	double *data;
}Tone;
typedef	struct	ToneTable{
	char fn[200];
	int	STEP;//Signal step
	int RGB;//Number of RGB
	double Tone_Table_Min;
	double Tone_Table_Max;
	int Tone_Table_Size;
	unsigned char *data;
}ToneTable;
typedef	struct	ROI{
	char fn[200];
	int *SX;
	int *SY;
	int *EX;
	int *EY;
	double *AREA;
	int Num;
}ROI;

double *wieCOV(char *fn_Tra,int INTERVAL,int START,int END);// Male Covariance matrix for wiener matrix
double *wieMCOV(double Prob,int WL,int INTERVAL,int START,int END);//marcov covariance matrix
double *SysMat(Wie *Wmat,Spec *Fil,Spec *CCD,Spec *iIll,MSI *wSig);
double *WienerMat(Wie *Wmat,MSI *wSig);
double *WienerMat(Wie *Wmat,double *wSig);
Wie Do_Wmat(char *fn_sys, char *fn_wSig);
Wie Do_WmatIMSPEC(char *fn_sys, char *fn_wSig);// Impsec摜MSI֕ϊ鎞Wieners쐻֐
Wie Do_WmatIMSPEC(void);//Imspec摜̃vt@C͂邾Bwieners͍Ȃ̂ŒӁII


Spec	xyzSpecGet(char *fn_xyz,char *fn_oIll,int START,int END,int INTERVAL);
Disp DispGet(char *fn_prima,Spec xyzfunc,int START,int END,int INTERVAL);
Tone DispTone256(char *fn_tone,char *fn_step,int para);// Make Table (input rgb signal -> luminance of rgb spectral)
Tone ToneGet(char *fn);
ToneTable ToneTableGet(char *fn_tone);
void RGBGet(double *irgb,unsigned char *orgb,ToneTable *table);
void Do_NVcolor(void);

void NV_RGB(char *fn_wms,char *fn_oms);
void NV_RGB(char *fn_sys,char *fn_wms,char *fn_oms);

void ChangeBAND_MSI_sum(char *fn_band,char *fn_Osig);//ςASYԈĂ֐Ȃ̂ŎgpȂŉII
void ChangeBAND_MSI_average(char *fn_band,char *fn_wsig,char *fn_Osig);//ςASY

Wie ChangeBand_Wmat(char *fn_Sel,Wie *wimat);
void ChangeBAND_MSI(char *fn_band,char *fn_wsig,char *fn_Osig);//by using estimated transmittance
void ChangeBAND_MSI(char *fn_wsig,char *fn_Osig);//by using estimated transmittance
void USimgConvertRGB(char *fn);
void changeband(void);
ROI ROIGet(char *fn);
double *XYZtoLab(double *xyz,double *wxyz,int Num,int Dim);
void Lab(void);

//output file
void Fwrite_NVmat(char *fn,Wie *wimat,double *mat);
void FwriteChangeBandMatrix(char *fn_band,char *fn_wsig);
void Fwrite_ROI(char *fn,ROI *roi);
void Fwrite_StoXmat(char *fn_wsig);
void NV_Bar(char *fn_wms,char *fn_oms);// {//@fn_wms͔摜@fn_omsɂ͓ߗf[^

// Output Signal data
void GetSignal(char *fn_wsig,char *fn_Osig,char *fn_ROI);

void NV_XYZ(char *fn_wms,char *fn_oms,char *fn_sys);
void XYZtoLAB(double *xyz,double *wxyz,double *Lab);
void NV_LAB(char *fn_wms,char *fn_oms,char *fn_sys);
void dE_color_diff(char *orig_lab_fn,char *comp_lab_fn);
double color_diff(double *orig_lab,double *comp_lab);
