//#include <iostream>
//#include <stdlib.h>
//#include <math.h>
//#include <windows.h>

/**
 * @brief K(Normally Distributed Random Numbers)𐶐邽߂̃NX
 *        Box-Muller transform ASYɊÂB
 */
class NormDistRand
{
	private:
		double m_n1; // 2g̈l  Box-Muller transform l1
		double m_n2; // 2g̈l  Box-Muller transform l2

		bool   m_flg_n2_cached;

		double m_mean;   // Kz̕
		double m_stddev; // Kz̕W΍

//		static const double PI;
	public:

		/// constructor
		NormDistRand(double mean, double stddev) : 
		m_mean(mean), m_stddev(stddev), m_flg_n2_cached(false)
		{
			unsigned long tv = GetTickCount();
			srand(static_cast<unsigned int>(tv));
		}

		/// constructor
		NormDistRand(double mean, double stddev, unsigned int seed) : 
		m_mean(mean), m_stddev(stddev), m_flg_n2_cached(false)
		{ srand(seed); }

		/**
		* @brief Kl𐶐ĕԂB
		* @param [out] K
		*/
		double rand(void);

	private:

		/// inhibit using default constructor.
		NormDistRand();

		/**
		* @brief Box-Muller transform {Ĉl m_n1, m_n2 ɕϊB
		*/
		void _box_muller_transform(void);
};

